// DigitalMix.java
// Mix of events and polling
// Press/release switch at port I1, turn potentiometer at AX

import ch.aplu.util.*;
import ch.aplu.ftcontroller.*;

public class DigitalMix
  implements DigitalListener, ExitListener
{
  private volatile boolean isRunning = true;

  public DigitalMix()
  {
    Console c = Console.init();
    c.addExitListener(this);
    FtController fc = new FtController();
    fc.addDigitalListener(this);
    System.out.println("Press/release switch and turn potentiometer");
    while (isRunning)
    {
      fc.delay(500);
      int value = fc.resistorIn1.getValue();
      System.out.println("Resistance: " + value);
    }
    fc.exit();
  }

  public void digitalChanged(DigitalEvent evt)
  {
    System.out.println("DigitalIn: " + evt.getValue());
  }

  public void notifyExit()
  {
    isRunning = false;
  }

  public static void main(String[] args)
  {
    new DigitalMix();
  }
}
