// DigitalPoll.java
// Poll at digital-in
// Press/release several switches at ports I1..I8 simultaneously or sequentially

import ch.aplu.util.*;
import ch.aplu.ftcontroller.*;

public class DigitalPoll implements ExitListener
{
  private volatile boolean isRunning = true;
  
  public DigitalPoll()
  {
    Console c = Console.init();
    c.addExitListener(this);
    FtController fc = new FtController();
    System.out.println("Press/release any switch at digital-in.");
    System.out.println("(Multiple switch action supported)");
   
    while (isRunning)
    {
      fc.delay(500);
      int value = fc.digitalIn.getValue();
      System.out.println("Value: " + value);
      int mask = 1;
      for (int portNb = 1; portNb <=8; portNb++)
      {
        if ((value & mask) != 0)
          System.out.println("Switch " + portNb +  " On");
        else
          System.out.println("Switch " + portNb +  " Off");
        mask *=2;
      }
    }  
    fc.exit();
  }
    
  public void notifyExit()
  {
    isRunning = false;
  }
    
  public static void main(String[] args)
  {
    new DigitalPoll();
  }
}
