// DistanceEvt.java
// Ultrasonic distance sensor at D1

import ch.aplu.util.*;
import ch.aplu.ftcontroller.*;

public class DistanceEvt implements DistanceListener, Cleanable
{
  private ModelessOptionPane mop = new ModelessOptionPane("");
  private FtController fc = new FtController();

  public DistanceEvt()
  {
    fc.addDistanceListener(this, 1);
    mop.showTitle("Distance Sensor D1");
    mop.addCleanable(this);
  }

  public void distanceChanged(DistanceEvent evt)
  {
    mop.setText("Distance: " + evt.getDistance() + " cm");
  }
    

  public void clean()
  {
    fc.exit();
  }

  public static void main(String[] args)
  {
    new DistanceEvt();
  }
}
