// FtCommand.java

import java.awt.*;
import ch.aplu.ftcontroller.*;
import java.awt.event.*;
import javax.swing.*;

public class FtCommand extends javax.swing.JFrame
  implements DigitalListener, AnalogListener, ResistorListener, DistanceListener,
  ConnectionListener, CounterListener, MotorListener
{

  private final String version = "V1.1 - June 2009";


  private class MyActionListener implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      for (int i = 0; i < 4; i++)
      {
        int newJitterValue = getJitterValue(i);
        if (jitterValues[i] != newJitterValue)
        {
          jitterValues[i] = newJitterValue;
          switch (i)
          {
            case 0:
              fc.analogIn1.setJitter(newJitterValue);
              break;
            case 1:
              fc.analogIn2.setJitter(newJitterValue);
              break;
            case 2:
              fc.resistorIn1.setJitter(newJitterValue);
              break;
            case 3:
              fc.resistorIn2.setJitter(newJitterValue);
              break;
          }
        }
      }
    }
  }

  /** Creates new form FtCommand */
  public FtCommand()
  {
    initComponents();
    initPanel();
    doConnect(true);
  }

  private void initPanel()
  {
    fc = new FtController(false);
    fc.addDigitalListener(this);
    fc.addAnalogListener(this, 1);
    fc.addAnalogListener(this, 2);
    fc.addResistorListener(this, 1);
    fc.addResistorListener(this, 2);
    fc.addDistanceListener(this, 1);
    fc.addDistanceListener(this, 2);
    fc.addConnectionListener(this);
    for (int i = 1; i <= 8; i++)
      fc.addCounterListener(this, i);
    fc.addCounterListener(this, 1);
    for (int i = 1; i <= 4; i++)
      fc.addMotorListener(this, i);
    digitalIn[0] = din1;
    digitalIn[1] = din2;
    digitalIn[2] = din3;
    digitalIn[3] = din4;
    digitalIn[4] = din5;
    digitalIn[5] = din6;
    digitalIn[6] = din7;
    digitalIn[7] = din8;
    lamps[0] = fc.lamp1;
    lamps[1] = fc.lamp2;
    lamps[2] = fc.lamp3;
    lamps[3] = fc.lamp4;
    lamps[4] = fc.lamp5;
    lamps[5] = fc.lamp6;
    lamps[6] = fc.lamp7;
    lamps[7] = fc.lamp8;
    lampz[0] = dval1;
    lampz[1] = dval2;
    lampz[2] = dval3;
    lampz[3] = dval4;
    lampz[4] = dval5;
    lampz[5] = dval6;
    lampz[6] = dval7;
    lampz[7] = dval8;
    motors[0] = fc.motor1;
    motors[1] = fc.motor2;
    motors[2] = fc.motor3;
    motors[3] = fc.motor4;
    mSpeeds[0] = mspeed1;
    mSpeeds[1] = mspeed2;
    mSpeeds[2] = mspeed3;
    mSpeeds[3] = mspeed4;
    mSteps[0] = msteps1;
    mSteps[1] = msteps2;
    mSteps[2] = msteps3;
    mSteps[3] = msteps4;
    mStatus[0] = motor1Status;
    mStatus[1] = motor2Status;
    mStatus[2] = motor3Status;
    mStatus[3] = motor4Status;
    counters[0] = fc.counter1;
    counters[1] = fc.counter2;
    counters[2] = fc.counter3;
    counters[3] = fc.counter4;
    counters[4] = fc.counter5;
    counters[5] = fc.counter6;
    counters[6] = fc.counter7;
    counters[7] = fc.counter8;
    counterValues[0] = count1;
    counterValues[1] = count2;
    counterValues[2] = count3;
    counterValues[3] = count4;
    counterValues[4] = count5;
    counterValues[5] = count6;
    counterValues[6] = count7;
    counterValues[7] = count8;
    counterButtons[0] = cb1;
    counterButtons[1] = cb2;
    counterButtons[2] = cb3;
    counterButtons[3] = cb4;
    counterButtons[4] = cb5;
    counterButtons[5] = cb6;
    counterButtons[6] = cb7;
    counterButtons[7] = cb8;
    connectionBtn.setEnabled(false);
    a1.setBackground(new Color(204, 255, 204));
    a2.setBackground(new Color(204, 255, 204));
    ax.setBackground(new Color(204, 255, 204));
    ay.setBackground(new Color(204, 255, 204));
    d1.setBackground(new Color(204, 255, 204));
    d2.setBackground(new Color(204, 255, 204));
    for (int i = 0; i < 8; i++)
    {
      digitalIn[i].setEditable(false);
      digitalIn[i].setBackground(Color.red);
    }
    for (int i = 0; i < 4; i++)
      mStatus[i].setText("Stopped");
    connectField.setEditable(false);
    connectField.setBackground(Color.red);
    setTitle("Fischertechnik Command Panel " + version + " (www.aplu.ch)");
    jitters[0] = a1jitter;
    jitters[1] = a2jitter;
    jitters[2] = axjitter;
    jitters[3] = ayjitter;
    for (int i = 0; i < 4; i++)
    {
      jitterValues[i] = 0;
      jitters[i].setText("0");
    }
    Timer pollTimer = new Timer(1000, new MyActionListener());
    pollTimer.start();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPanel4 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    dout4 = new javax.swing.JCheckBox();
    dout7 = new javax.swing.JCheckBox();
    dout5 = new javax.swing.JCheckBox();
    dout2 = new javax.swing.JCheckBox();
    dout1 = new javax.swing.JCheckBox();
    dout8 = new javax.swing.JCheckBox();
    dout3 = new javax.swing.JCheckBox();
    dout6 = new javax.swing.JCheckBox();
    dval1 = new javax.swing.JTextField();
    dval2 = new javax.swing.JTextField();
    dval3 = new javax.swing.JTextField();
    dval4 = new javax.swing.JTextField();
    dval5 = new javax.swing.JTextField();
    dval6 = new javax.swing.JTextField();
    dval7 = new javax.swing.JTextField();
    dval8 = new javax.swing.JTextField();
    jLabel9 = new javax.swing.JLabel();
    jLabel12 = new javax.swing.JLabel();
    jLabel13 = new javax.swing.JLabel();
    jLabel16 = new javax.swing.JLabel();
    jLabel17 = new javax.swing.JLabel();
    jLabel18 = new javax.swing.JLabel();
    jLabel19 = new javax.swing.JLabel();
    jLabel20 = new javax.swing.JLabel();
    jPanel1 = new javax.swing.JPanel();
    din1 = new javax.swing.JTextField();
    din2 = new javax.swing.JTextField();
    din3 = new javax.swing.JTextField();
    din4 = new javax.swing.JTextField();
    din5 = new javax.swing.JTextField();
    din6 = new javax.swing.JTextField();
    din7 = new javax.swing.JTextField();
    din8 = new javax.swing.JTextField();
    jLabel1 = new javax.swing.JLabel();
    jLabel2 = new javax.swing.JLabel();
    jLabel3 = new javax.swing.JLabel();
    jLabel4 = new javax.swing.JLabel();
    jLabel5 = new javax.swing.JLabel();
    jLabel6 = new javax.swing.JLabel();
    jLabel7 = new javax.swing.JLabel();
    jLabel8 = new javax.swing.JLabel();
    jLabel41 = new javax.swing.JLabel();
    quitBtn = new javax.swing.JButton();
    jPanel14 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    jLabel11 = new javax.swing.JLabel();
    a1 = new javax.swing.JTextField();
    jLabel10 = new javax.swing.JLabel();
    a2 = new javax.swing.JTextField();
    a1jitter = new javax.swing.JTextField();
    jLabel43 = new javax.swing.JLabel();
    a2jitter = new javax.swing.JTextField();
    jPanel3 = new javax.swing.JPanel();
    jLabel14 = new javax.swing.JLabel();
    ax = new javax.swing.JTextField();
    jLabel15 = new javax.swing.JLabel();
    ay = new javax.swing.JTextField();
    axjitter = new javax.swing.JTextField();
    jLabel45 = new javax.swing.JLabel();
    ayjitter = new javax.swing.JTextField();
    jPanel12 = new javax.swing.JPanel();
    jLabel47 = new javax.swing.JLabel();
    d1 = new javax.swing.JTextField();
    jLabel48 = new javax.swing.JLabel();
    d2 = new javax.swing.JTextField();
    jLabel44 = new javax.swing.JLabel();
    jLabel46 = new javax.swing.JLabel();
    jPanel15 = new javax.swing.JPanel();
    jPanel6 = new javax.swing.JPanel();
    fwd1 = new javax.swing.JButton();
    back1 = new javax.swing.JButton();
    msteps1 = new javax.swing.JTextField();
    jLabel22 = new javax.swing.JLabel();
    jLabel24 = new javax.swing.JLabel();
    stop1 = new javax.swing.JButton();
    mspeed1 = new javax.swing.JTextField();
    jLabel23 = new javax.swing.JLabel();
    motor1Status = new javax.swing.JLabel();
    jPanel7 = new javax.swing.JPanel();
    fwd2 = new javax.swing.JButton();
    back2 = new javax.swing.JButton();
    msteps2 = new javax.swing.JTextField();
    jLabel25 = new javax.swing.JLabel();
    jLabel26 = new javax.swing.JLabel();
    stop2 = new javax.swing.JButton();
    mspeed2 = new javax.swing.JTextField();
    jLabel27 = new javax.swing.JLabel();
    motor2Status = new javax.swing.JLabel();
    jPanel8 = new javax.swing.JPanel();
    fwd3 = new javax.swing.JButton();
    back3 = new javax.swing.JButton();
    msteps3 = new javax.swing.JTextField();
    jLabel28 = new javax.swing.JLabel();
    jLabel29 = new javax.swing.JLabel();
    stop3 = new javax.swing.JButton();
    mspeed3 = new javax.swing.JTextField();
    jLabel30 = new javax.swing.JLabel();
    motor3Status = new javax.swing.JLabel();
    jPanel9 = new javax.swing.JPanel();
    fwd4 = new javax.swing.JButton();
    back4 = new javax.swing.JButton();
    msteps4 = new javax.swing.JTextField();
    jLabel31 = new javax.swing.JLabel();
    jLabel32 = new javax.swing.JLabel();
    stop4 = new javax.swing.JButton();
    mspeed4 = new javax.swing.JTextField();
    jLabel33 = new javax.swing.JLabel();
    motor4Status = new javax.swing.JLabel();
    jPanel13 = new javax.swing.JPanel();
    jPanel10 = new javax.swing.JPanel();
    count1 = new javax.swing.JTextField();
    count2 = new javax.swing.JTextField();
    count3 = new javax.swing.JTextField();
    count4 = new javax.swing.JTextField();
    count5 = new javax.swing.JTextField();
    count6 = new javax.swing.JTextField();
    count7 = new javax.swing.JTextField();
    count8 = new javax.swing.JTextField();
    cb1 = new javax.swing.JButton();
    cb2 = new javax.swing.JButton();
    cb3 = new javax.swing.JButton();
    cb4 = new javax.swing.JButton();
    cb5 = new javax.swing.JButton();
    cb6 = new javax.swing.JButton();
    cb7 = new javax.swing.JButton();
    cb8 = new javax.swing.JButton();
    jLabel21 = new javax.swing.JLabel();
    jLabel34 = new javax.swing.JLabel();
    jLabel35 = new javax.swing.JLabel();
    jLabel36 = new javax.swing.JLabel();
    jLabel37 = new javax.swing.JLabel();
    jLabel38 = new javax.swing.JLabel();
    jLabel39 = new javax.swing.JLabel();
    jLabel40 = new javax.swing.JLabel();
    jLabel42 = new javax.swing.JLabel();
    jPanel16 = new javax.swing.JPanel();
    jPanel11 = new javax.swing.JPanel();
    connectionLabel = new javax.swing.JLabel();
    controllerInfo = new javax.swing.JLabel();
    connectionBtn = new javax.swing.JButton();
    connectField = new javax.swing.JTextField();

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    setResizable(false);

    jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("Digital Outputs"));

    dout4.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        dout4ItemStateChanged(evt);
      }
    });

    dout7.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        dout7ItemStateChanged(evt);
      }
    });

    dout5.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        dout5ItemStateChanged(evt);
      }
    });

    dout2.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        dout2ItemStateChanged(evt);
      }
    });

    dout1.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        dout1ItemStateChanged(evt);
      }
    });

    dout8.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        dout8ItemStateChanged(evt);
      }
    });

    dout3.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        dout3ItemStateChanged(evt);
      }
    });

    dout6.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(java.awt.event.ItemEvent evt) {
        dout6ItemStateChanged(evt);
      }
    });

    dval1.setBackground(new java.awt.Color(204, 255, 204));
    dval1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
    dval1.setText("8");

    dval2.setBackground(new java.awt.Color(204, 255, 204));
    dval2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
    dval2.setText("8");

    dval3.setBackground(new java.awt.Color(204, 255, 204));
    dval3.setHorizontalAlignment(javax.swing.JTextField.CENTER);
    dval3.setText("8");

    dval4.setBackground(new java.awt.Color(204, 255, 204));
    dval4.setHorizontalAlignment(javax.swing.JTextField.CENTER);
    dval4.setText("8");

    dval5.setBackground(new java.awt.Color(204, 255, 204));
    dval5.setHorizontalAlignment(javax.swing.JTextField.CENTER);
    dval5.setText("8");

    dval6.setBackground(new java.awt.Color(204, 255, 204));
    dval6.setHorizontalAlignment(javax.swing.JTextField.CENTER);
    dval6.setText("8");

    dval7.setBackground(new java.awt.Color(204, 255, 204));
    dval7.setHorizontalAlignment(javax.swing.JTextField.CENTER);
    dval7.setText("8");

    dval8.setBackground(new java.awt.Color(204, 255, 204));
    dval8.setHorizontalAlignment(javax.swing.JTextField.CENTER);
    dval8.setText("8");

    jLabel9.setText("Nb:1");

    jLabel12.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel12.setText("2");

    jLabel13.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel13.setText("3");

    jLabel16.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel16.setText("4");

    jLabel17.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel17.setText("5");

    jLabel18.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel18.setText("6");

    jLabel19.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel19.setText("7");

    jLabel20.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel20.setText("8");

    javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
    jPanel5.setLayout(jPanel5Layout);
    jPanel5Layout.setHorizontalGroup(
      jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel5Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addComponent(dout1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
          .addComponent(dval1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel9))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
          .addComponent(dout2, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
          .addComponent(dval2, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(jLabel13, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
          .addComponent(dout3, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
          .addComponent(dval3, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(jLabel16, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
          .addComponent(dout4, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
          .addComponent(dval4, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(jLabel17, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
          .addComponent(dout5, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
          .addComponent(dval5, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(jLabel18, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(dout6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(dval6))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(jLabel19, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(dout7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(dval7))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(jLabel20, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
          .addComponent(dout8, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
          .addComponent(dval8, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)))
    );

    jPanel5Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {dout1, dout2, dout3, dout4, dout5, dout6, dout7, dout8});

    jPanel5Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {dval1, dval2, dval3, dval4, dval5, dval6, dval7, dval8});

    jPanel5Layout.setVerticalGroup(
      jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel5Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(dout3)
          .addComponent(dout2)
          .addComponent(dout1)
          .addComponent(dout4)
          .addComponent(dout5)
          .addComponent(dout6)
          .addComponent(dout7)
          .addComponent(dout8))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 5, Short.MAX_VALUE)
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(dval1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(dval2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(dval3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(dval4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(dval5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(dval6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(dval7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(dval8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel9)
          .addComponent(jLabel12)
          .addComponent(jLabel13)
          .addComponent(jLabel16)
          .addComponent(jLabel17)
          .addComponent(jLabel18)
          .addComponent(jLabel19)
          .addComponent(jLabel20))
        .addContainerGap())
    );

    jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Digital Inputs"));

    jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel1.setText("1");

    jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel2.setText("2");

    jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel3.setText("3");

    jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel4.setText("4");

    jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel5.setText("5");

    jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel6.setText("6");

    jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel7.setText("7");

    jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel8.setText("8");

    jLabel41.setText("Nb:");

    javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
    jPanel1.setLayout(jPanel1Layout);
    jPanel1Layout.setHorizontalGroup(
      jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel1Layout.createSequentialGroup()
        .addContainerGap()
        .addComponent(jLabel41)
        .addGap(2, 2, 2)
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
          .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(din1, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(din2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(din3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(din4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(jLabel5, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(din5, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(jLabel6, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(din6, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(jLabel7, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(din7, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
          .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(din8, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addContainerGap(20, Short.MAX_VALUE))
    );
    jPanel1Layout.setVerticalGroup(
      jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel1Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
            .addComponent(din1, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(11, 11, 11)
            .addComponent(jLabel1))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
            .addComponent(din2, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(11, 11, 11)
            .addComponent(jLabel2))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
            .addComponent(din3, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(11, 11, 11)
            .addComponent(jLabel3))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
            .addComponent(din4, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(11, 11, 11)
            .addComponent(jLabel4))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
            .addComponent(din5, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(11, 11, 11)
            .addComponent(jLabel5))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
            .addComponent(din6, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(11, 11, 11)
            .addComponent(jLabel6))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
            .addComponent(din7, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(11, 11, 11)
            .addComponent(jLabel7))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
            .addComponent(din8, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(11, 11, 11)
            .addComponent(jLabel8))
          .addComponent(jLabel41, javax.swing.GroupLayout.Alignment.TRAILING))
        .addContainerGap(31, Short.MAX_VALUE))
    );

    javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
    jPanel4.setLayout(jPanel4Layout);
    jPanel4Layout.setHorizontalGroup(
      jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel4Layout.createSequentialGroup()
        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 11, Short.MAX_VALUE)
        .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap())
    );
    jPanel4Layout.setVerticalGroup(
      jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel4Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        .addContainerGap())
    );

    quitBtn.setText("Quit");
    quitBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        quitButtonActionPerformed(evt);
      }
    });

    jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Analog Inputs"));

    jLabel11.setText("A1");

    a1.setBackground(new java.awt.Color(204, 255, 204));
    a1.setEditable(false);
    a1.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    a1.setText("1234");

    jLabel10.setText("A2");

    a2.setBackground(new java.awt.Color(204, 255, 204));
    a2.setEditable(false);
    a2.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    a2.setText("1234");

    a1jitter.setBackground(new java.awt.Color(204, 255, 204));
    a1jitter.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

    jLabel43.setText("Jitter");

    a2jitter.setBackground(new java.awt.Color(204, 255, 204));
    a2jitter.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

    javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
    jPanel2.setLayout(jPanel2Layout);
    jPanel2Layout.setHorizontalGroup(
      jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel2Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addGroup(jPanel2Layout.createSequentialGroup()
            .addComponent(jLabel43)
            .addGap(17, 17, 17))
          .addGroup(jPanel2Layout.createSequentialGroup()
            .addComponent(jLabel11)
            .addGap(18, 18, 18)))
        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(a1jitter)
          .addComponent(a1, javax.swing.GroupLayout.DEFAULT_SIZE, 36, Short.MAX_VALUE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jLabel10)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(a2jitter, javax.swing.GroupLayout.DEFAULT_SIZE, 39, Short.MAX_VALUE)
          .addComponent(a2, javax.swing.GroupLayout.DEFAULT_SIZE, 39, Short.MAX_VALUE))
        .addContainerGap())
    );

    jPanel2Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {a1, a2});

    jPanel2Layout.setVerticalGroup(
      jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel2Layout.createSequentialGroup()
        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(a1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(a2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel10)
          .addComponent(jLabel11))
        .addGap(12, 12, 12)
        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(a1jitter)
          .addComponent(a2jitter, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel43)))
    );

    jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Resistor Inputs"));

    jLabel14.setText("AX");

    ax.setBackground(new java.awt.Color(204, 255, 204));
    ax.setEditable(false);
    ax.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    ax.setText("1234");

    jLabel15.setText("AY");

    ay.setBackground(new java.awt.Color(204, 255, 204));
    ay.setEditable(false);
    ay.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    ay.setText("1234");

    axjitter.setBackground(new java.awt.Color(204, 255, 204));
    axjitter.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

    jLabel45.setText("Jitter");

    ayjitter.setBackground(new java.awt.Color(204, 255, 204));
    ayjitter.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

    javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
    jPanel3.setLayout(jPanel3Layout);
    jPanel3Layout.setHorizontalGroup(
      jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel3Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addComponent(jLabel45)
          .addComponent(jLabel14))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(axjitter)
          .addComponent(ax, javax.swing.GroupLayout.DEFAULT_SIZE, 36, Short.MAX_VALUE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jLabel15)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(ayjitter, javax.swing.GroupLayout.DEFAULT_SIZE, 50, Short.MAX_VALUE)
          .addComponent(ay, javax.swing.GroupLayout.DEFAULT_SIZE, 41, Short.MAX_VALUE))
        .addContainerGap())
    );

    jPanel3Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {ax, ay});

    jPanel3Layout.setVerticalGroup(
      jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel3Layout.createSequentialGroup()
        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(ax, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(ay, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel15)
          .addComponent(jLabel14))
        .addGap(12, 12, 12)
        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(axjitter, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(ayjitter, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel45))
        .addContainerGap(12, Short.MAX_VALUE))
    );

    jPanel12.setBorder(javax.swing.BorderFactory.createTitledBorder("Distance Sensor"));

    jLabel47.setText("D1");

    d1.setBackground(new java.awt.Color(204, 255, 204));
    d1.setEditable(false);
    d1.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    d1.setText("1234");

    jLabel48.setText("D2");

    d2.setBackground(new java.awt.Color(204, 255, 204));
    d2.setEditable(false);
    d2.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    d2.setText("1234");

    jLabel44.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
    jLabel44.setText("cm");

    jLabel46.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
    jLabel46.setText("cm");

    javax.swing.GroupLayout jPanel12Layout = new javax.swing.GroupLayout(jPanel12);
    jPanel12.setLayout(jPanel12Layout);
    jPanel12Layout.setHorizontalGroup(
      jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel12Layout.createSequentialGroup()
        .addContainerGap()
        .addComponent(jLabel47)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(jPanel12Layout.createSequentialGroup()
            .addComponent(d1, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(16, 16, 16)
            .addComponent(jLabel48))
          .addComponent(jLabel44, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(d2, javax.swing.GroupLayout.DEFAULT_SIZE, 43, Short.MAX_VALUE)
          .addComponent(jLabel46, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addContainerGap())
    );

    jPanel12Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {d1, d2});

    jPanel12Layout.setVerticalGroup(
      jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel12Layout.createSequentialGroup()
        .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(d2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel48)
          .addComponent(jLabel47)
          .addComponent(d1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel44)
          .addComponent(jLabel46))
        .addContainerGap(24, Short.MAX_VALUE))
    );

    javax.swing.GroupLayout jPanel14Layout = new javax.swing.GroupLayout(jPanel14);
    jPanel14.setLayout(jPanel14Layout);
    jPanel14Layout.setHorizontalGroup(
      jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel14Layout.createSequentialGroup()
        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addGap(18, 18, 18)
        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 18, Short.MAX_VALUE)
        .addComponent(jPanel12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(12, Short.MAX_VALUE))
    );

    jPanel14Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jPanel12, jPanel2, jPanel3});

    jPanel14Layout.setVerticalGroup(
      jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel14Layout.createSequentialGroup()
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(jPanel14Layout.createSequentialGroup()
            .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap())
          .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel14Layout.createSequentialGroup()
              .addComponent(jPanel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
              .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
    );

    jPanel14Layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jPanel12, jPanel2, jPanel3});

    jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder("Motor 1"));

    fwd1.setText("Right");
    fwd1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        fwd1ActionPerformed(evt);
      }
    });

    back1.setText("Left");
    back1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        back1ActionPerformed(evt);
      }
    });

    msteps1.setBackground(new java.awt.Color(204, 255, 204));
    msteps1.setColumns(3);
    msteps1.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    msteps1.setText("0");

    jLabel22.setText("Steps:");

    jLabel24.setText("0: until stop");

    stop1.setText("Stop");
    stop1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        stop1ActionPerformed(evt);
      }
    });

    mspeed1.setBackground(new java.awt.Color(204, 255, 204));
    mspeed1.setColumns(3);
    mspeed1.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    mspeed1.setText("1");

    jLabel23.setText("Speed:");

    motor1Status.setForeground(new java.awt.Color(0, 0, 255));
    motor1Status.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    motor1Status.setText("Status");

    javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
    jPanel6.setLayout(jPanel6Layout);
    jPanel6Layout.setHorizontalGroup(
      jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel6Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
            .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addGroup(jPanel6Layout.createSequentialGroup()
                .addComponent(jLabel23)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(mspeed1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
              .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(jLabel24)
                .addGroup(jPanel6Layout.createSequentialGroup()
                  .addComponent(jLabel22)
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                  .addComponent(msteps1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
            .addGap(26, 26, 26))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
            .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addComponent(fwd1, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
              .addComponent(back1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
              .addComponent(stop1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE))
            .addContainerGap())
          .addGroup(jPanel6Layout.createSequentialGroup()
            .addComponent(motor1Status, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
            .addContainerGap())))
    );
    jPanel6Layout.setVerticalGroup(
      jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel6Layout.createSequentialGroup()
        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel23)
          .addComponent(mspeed1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addGap(5, 5, 5)
        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(msteps1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel22))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jLabel24)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(fwd1)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(back1)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(stop1)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(motor1Status))
    );

    jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder("Motor 2"));

    fwd2.setText("Right");
    fwd2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        fwd2ActionPerformed(evt);
      }
    });

    back2.setText("Left");
    back2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        back2ActionPerformed(evt);
      }
    });

    msteps2.setBackground(new java.awt.Color(204, 255, 204));
    msteps2.setColumns(3);
    msteps2.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    msteps2.setText("0");

    jLabel25.setText("Steps:");

    jLabel26.setText("0: until stop");

    stop2.setText("Stop");
    stop2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        stop2ActionPerformed(evt);
      }
    });

    mspeed2.setBackground(new java.awt.Color(204, 255, 204));
    mspeed2.setColumns(3);
    mspeed2.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    mspeed2.setText("1");

    jLabel27.setText("Speed:");

    motor2Status.setForeground(new java.awt.Color(0, 0, 255));
    motor2Status.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    motor2Status.setText("Status");

    javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
    jPanel7.setLayout(jPanel7Layout);
    jPanel7Layout.setHorizontalGroup(
      jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel7Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel7Layout.createSequentialGroup()
            .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addGroup(jPanel7Layout.createSequentialGroup()
                .addComponent(jLabel27)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(mspeed2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
              .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(jLabel26)
                .addGroup(jPanel7Layout.createSequentialGroup()
                  .addComponent(jLabel25)
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                  .addComponent(msteps2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
            .addGap(26, 26, 26))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel7Layout.createSequentialGroup()
            .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addComponent(motor2Status, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
              .addComponent(fwd2, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
              .addComponent(back2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
              .addComponent(stop2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE))
            .addContainerGap())))
    );
    jPanel7Layout.setVerticalGroup(
      jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel7Layout.createSequentialGroup()
        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel27)
          .addComponent(mspeed2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addGap(5, 5, 5)
        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(msteps2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel25))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jLabel26)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(fwd2)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(back2)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(stop2)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(motor2Status))
    );

    jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder("Motor 3"));

    fwd3.setText("Right");
    fwd3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        fwd3ActionPerformed(evt);
      }
    });

    back3.setText("Left");
    back3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        back3ActionPerformed(evt);
      }
    });

    msteps3.setBackground(new java.awt.Color(204, 255, 204));
    msteps3.setColumns(3);
    msteps3.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    msteps3.setText("0");

    jLabel28.setText("Steps:");

    jLabel29.setText("0: until stop");

    stop3.setText("Stop");
    stop3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        stop3ActionPerformed(evt);
      }
    });

    mspeed3.setBackground(new java.awt.Color(204, 255, 204));
    mspeed3.setColumns(3);
    mspeed3.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    mspeed3.setText("1");

    jLabel30.setText("Speed:");

    motor3Status.setForeground(java.awt.Color.blue);
    motor3Status.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    motor3Status.setText("Status");

    javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
    jPanel8.setLayout(jPanel8Layout);
    jPanel8Layout.setHorizontalGroup(
      jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel8Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel8Layout.createSequentialGroup()
            .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addGroup(jPanel8Layout.createSequentialGroup()
                .addComponent(jLabel30)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(mspeed3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
              .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(jLabel29)
                .addGroup(jPanel8Layout.createSequentialGroup()
                  .addComponent(jLabel28)
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                  .addComponent(msteps3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
            .addGap(26, 26, 26))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel8Layout.createSequentialGroup()
            .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addComponent(motor3Status, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
              .addComponent(fwd3, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
              .addComponent(back3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
              .addComponent(stop3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE))
            .addContainerGap())))
    );
    jPanel8Layout.setVerticalGroup(
      jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel8Layout.createSequentialGroup()
        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel30)
          .addComponent(mspeed3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addGap(5, 5, 5)
        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(msteps3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel28))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jLabel29)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(fwd3)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(back3)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(stop3)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(motor3Status))
    );

    jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder("Motor 4"));

    fwd4.setText("Right");
    fwd4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        fwd4ActionPerformed(evt);
      }
    });

    back4.setText("Left");
    back4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        back4ActionPerformed(evt);
      }
    });

    msteps4.setBackground(new java.awt.Color(204, 255, 204));
    msteps4.setColumns(3);
    msteps4.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    msteps4.setText("0");

    jLabel31.setText("Steps:");

    jLabel32.setText("0: until stop");

    stop4.setText("Stop");
    stop4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        stop4ActionPerformed(evt);
      }
    });

    mspeed4.setBackground(new java.awt.Color(204, 255, 204));
    mspeed4.setColumns(3);
    mspeed4.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    mspeed4.setText("1");

    jLabel33.setText("Speed:");

    motor4Status.setForeground(java.awt.Color.blue);
    motor4Status.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    motor4Status.setText("Status");

    javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
    jPanel9.setLayout(jPanel9Layout);
    jPanel9Layout.setHorizontalGroup(
      jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel9Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
            .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addGroup(jPanel9Layout.createSequentialGroup()
                .addComponent(jLabel33)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(mspeed4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
              .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(jLabel32)
                .addGroup(jPanel9Layout.createSequentialGroup()
                  .addComponent(jLabel31)
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                  .addComponent(msteps4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
            .addGap(26, 26, 26))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
            .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addComponent(motor4Status, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 110, Short.MAX_VALUE)
              .addComponent(fwd4, javax.swing.GroupLayout.DEFAULT_SIZE, 110, Short.MAX_VALUE)
              .addComponent(back4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 110, Short.MAX_VALUE)
              .addComponent(stop4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 110, Short.MAX_VALUE))
            .addContainerGap())))
    );
    jPanel9Layout.setVerticalGroup(
      jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel9Layout.createSequentialGroup()
        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel33)
          .addComponent(mspeed4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addGap(5, 5, 5)
        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(msteps4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel31))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jLabel32)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(fwd4)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(back4)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(stop4)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(motor4Status))
    );

    javax.swing.GroupLayout jPanel15Layout = new javax.swing.GroupLayout(jPanel15);
    jPanel15.setLayout(jPanel15Layout);
    jPanel15Layout.setHorizontalGroup(
      jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel15Layout.createSequentialGroup()
        .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    );

    jPanel15Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jPanel6, jPanel7, jPanel8});

    jPanel15Layout.setVerticalGroup(
      jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel15Layout.createSequentialGroup()
        .addGroup(jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addGroup(jPanel15Layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
          .addGroup(jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel7, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel8, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        .addContainerGap())
    );

    jPanel15Layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jPanel6, jPanel7, jPanel8, jPanel9});

    jPanel10.setBorder(javax.swing.BorderFactory.createTitledBorder("Counters"));

    count1.setBackground(new java.awt.Color(204, 255, 204));
    count1.setColumns(6);
    count1.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    count1.setText("0");

    count2.setBackground(new java.awt.Color(204, 255, 204));
    count2.setColumns(6);
    count2.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    count2.setText("0");
    count2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        count2ActionPerformed(evt);
      }
    });

    count3.setBackground(new java.awt.Color(204, 255, 204));
    count3.setColumns(6);
    count3.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    count3.setText("0");

    count4.setBackground(new java.awt.Color(204, 255, 204));
    count4.setColumns(6);
    count4.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    count4.setText("0");

    count5.setBackground(new java.awt.Color(204, 255, 204));
    count5.setColumns(6);
    count5.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    count5.setText("0");

    count6.setBackground(new java.awt.Color(204, 255, 204));
    count6.setColumns(6);
    count6.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    count6.setText("0");

    count7.setBackground(new java.awt.Color(204, 255, 204));
    count7.setColumns(6);
    count7.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    count7.setText("0");

    count8.setBackground(new java.awt.Color(204, 255, 204));
    count8.setColumns(6);
    count8.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    count8.setText("0");

    cb1.setText("Set");
    cb1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cb1ActionPerformed(evt);
      }
    });

    cb2.setText("Set");
    cb2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cb2ActionPerformed(evt);
      }
    });

    cb3.setText("Set");
    cb3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cb3ActionPerformed(evt);
      }
    });

    cb4.setText("Set");
    cb4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cb4ActionPerformed(evt);
      }
    });

    cb5.setText("Set");
    cb5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cb5ActionPerformed(evt);
      }
    });

    cb6.setText("Set");
    cb6.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cb6ActionPerformed(evt);
      }
    });

    cb7.setText("Set");
    cb7.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cb7ActionPerformed(evt);
      }
    });

    cb8.setText("Set");
    cb8.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cb8ActionPerformed(evt);
      }
    });

    jLabel21.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel21.setText("1");

    jLabel34.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel34.setText("2");

    jLabel35.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel35.setText("3");

    jLabel36.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel36.setText("4");

    jLabel37.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel37.setText("5");

    jLabel38.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel38.setText("6");

    jLabel39.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel39.setText("7");

    jLabel40.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel40.setText("8");

    jLabel42.setText("Nb:");

    javax.swing.GroupLayout jPanel10Layout = new javax.swing.GroupLayout(jPanel10);
    jPanel10.setLayout(jPanel10Layout);
    jPanel10Layout.setHorizontalGroup(
      jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel10Layout.createSequentialGroup()
        .addGap(10, 10, 10)
        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
          .addGroup(jPanel10Layout.createSequentialGroup()
            .addComponent(count1, 0, 0, Short.MAX_VALUE)
            .addGap(6, 6, 6)
            .addComponent(count2, 0, 0, Short.MAX_VALUE)
            .addGap(6, 6, 6)
            .addComponent(count3, 0, 0, Short.MAX_VALUE)
            .addGap(6, 6, 6)
            .addComponent(count4, 0, 0, Short.MAX_VALUE)
            .addGap(6, 6, 6)
            .addComponent(count5, 0, 0, Short.MAX_VALUE)
            .addGap(6, 6, 6)
            .addComponent(count6, javax.swing.GroupLayout.PREFERRED_SIZE, 0, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(6, 6, 6)
            .addComponent(count7, 0, 0, Short.MAX_VALUE)
            .addGap(6, 6, 6)
            .addComponent(count8, 0, 0, Short.MAX_VALUE))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel10Layout.createSequentialGroup()
            .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
              .addGroup(jPanel10Layout.createSequentialGroup()
                .addComponent(cb1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(6, 6, 6)
                .addComponent(cb2)
                .addGap(6, 6, 6)
                .addComponent(cb3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(6, 6, 6)
                .addComponent(cb4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(6, 6, 6)
                .addComponent(cb5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(6, 6, 6)
                .addComponent(cb6)
                .addGap(6, 6, 6))
              .addGroup(jPanel10Layout.createSequentialGroup()
                .addComponent(jLabel42)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel21)
                .addGap(48, 48, 48)
                .addComponent(jLabel34, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(39, 39, 39)
                .addComponent(jLabel35)
                .addGap(55, 55, 55)
                .addComponent(jLabel36)
                .addGap(51, 51, 51)
                .addComponent(jLabel37)
                .addGap(51, 51, 51)
                .addComponent(jLabel38)
                .addGap(27, 27, 27)))
            .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
              .addGroup(jPanel10Layout.createSequentialGroup()
                .addComponent(cb7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(6, 6, 6))
              .addGroup(jPanel10Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jLabel39, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
            .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addComponent(cb8)
              .addGroup(jPanel10Layout.createSequentialGroup()
                .addComponent(jLabel40)
                .addGap(20, 20, 20)))))
        .addContainerGap())
    );

    jPanel10Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {cb1, cb2, cb3, cb4, cb5, cb6, cb7, cb8, count1, count2, count3, count4, count5, count6, count7, count8});

    jPanel10Layout.setVerticalGroup(
      jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel10Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(count3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(count1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(count6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(count2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(count4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(count5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(count7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(count8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(cb1)
          .addComponent(cb2)
          .addComponent(cb3)
          .addComponent(cb4)
          .addComponent(cb5)
          .addComponent(cb6)
          .addComponent(cb7)
          .addComponent(cb8))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel35, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel39)
          .addComponent(jLabel40)
          .addComponent(jLabel42)
          .addComponent(jLabel21, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel34, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel35, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel36)
          .addComponent(jLabel37)
          .addComponent(jLabel38)))
    );

    javax.swing.GroupLayout jPanel13Layout = new javax.swing.GroupLayout(jPanel13);
    jPanel13.setLayout(jPanel13Layout);
    jPanel13Layout.setHorizontalGroup(
      jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel13Layout.createSequentialGroup()
        .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(54, Short.MAX_VALUE))
    );
    jPanel13Layout.setVerticalGroup(
      jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel13Layout.createSequentialGroup()
        .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    );

    jPanel11.setBorder(javax.swing.BorderFactory.createTitledBorder("Connection Status"));

    connectionLabel.setText("Not connected");

    controllerInfo.setText("(no controller info)");

    connectionBtn.setText("Connect");
    connectionBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        connectionBtnActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout jPanel11Layout = new javax.swing.GroupLayout(jPanel11);
    jPanel11.setLayout(jPanel11Layout);
    jPanel11Layout.setHorizontalGroup(
      jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel11Layout.createSequentialGroup()
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(connectField, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addGap(26, 26, 26)
        .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
          .addComponent(controllerInfo, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(connectionLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(connectionBtn, javax.swing.GroupLayout.PREFERRED_SIZE, 93, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addGap(138, 138, 138))
    );
    jPanel11Layout.setVerticalGroup(
      jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel11Layout.createSequentialGroup()
        .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(connectionLabel)
          .addComponent(connectField, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(connectionBtn))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 13, Short.MAX_VALUE)
        .addComponent(controllerInfo))
    );

    javax.swing.GroupLayout jPanel16Layout = new javax.swing.GroupLayout(jPanel16);
    jPanel16.setLayout(jPanel16Layout);
    jPanel16Layout.setHorizontalGroup(
      jPanel16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel16Layout.createSequentialGroup()
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, 385, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addGap(182, 182, 182))
    );
    jPanel16Layout.setVerticalGroup(
      jPanel16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel16Layout.createSequentialGroup()
        .addContainerGap()
        .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(2, Short.MAX_VALUE))
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
    getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
            .addComponent(jPanel14, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel15, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
              .addComponent(jPanel16, javax.swing.GroupLayout.PREFERRED_SIZE, 399, javax.swing.GroupLayout.PREFERRED_SIZE)
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
              .addComponent(quitBtn, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addComponent(jPanel13, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
        .addContainerGap()
        .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jPanel14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jPanel15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jPanel13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addComponent(jPanel16, javax.swing.GroupLayout.DEFAULT_SIZE, 89, Short.MAX_VALUE)
          .addGroup(layout.createSequentialGroup()
            .addComponent(quitBtn)
            .addContainerGap())))
    );

    pack();
  }// </editor-fold>//GEN-END:initComponents

private void quitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_quitButtonActionPerformed
  connectField.setBackground(Color.red);
  cleanup();
}//GEN-LAST:event_quitButtonActionPerformed

private void connectionBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_connectionBtnActionPerformed
{//GEN-HEADEREND:event_connectionBtnActionPerformed
  doConnect(false);
}//GEN-LAST:event_connectionBtnActionPerformed

private void dout1ItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_dout1ItemStateChanged
{//GEN-HEADEREND:event_dout1ItemStateChanged
  handleLamp(evt, 1);
}//GEN-LAST:event_dout1ItemStateChanged

private void dout2ItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_dout2ItemStateChanged
{//GEN-HEADEREND:event_dout2ItemStateChanged
  handleLamp(evt, 2);
}//GEN-LAST:event_dout2ItemStateChanged

private void dout8ItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_dout8ItemStateChanged
{//GEN-HEADEREND:event_dout8ItemStateChanged
  handleLamp(evt, 8);
}//GEN-LAST:event_dout8ItemStateChanged

private void dout7ItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_dout7ItemStateChanged
{//GEN-HEADEREND:event_dout7ItemStateChanged
  handleLamp(evt, 7);
}//GEN-LAST:event_dout7ItemStateChanged

private void dout6ItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_dout6ItemStateChanged
{//GEN-HEADEREND:event_dout6ItemStateChanged
  handleLamp(evt, 6);
}//GEN-LAST:event_dout6ItemStateChanged

private void dout5ItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_dout5ItemStateChanged
{//GEN-HEADEREND:event_dout5ItemStateChanged
  handleLamp(evt, 5);
}//GEN-LAST:event_dout5ItemStateChanged

private void dout4ItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_dout4ItemStateChanged
{//GEN-HEADEREND:event_dout4ItemStateChanged
  handleLamp(evt, 4);
}//GEN-LAST:event_dout4ItemStateChanged

private void dout3ItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_dout3ItemStateChanged
{//GEN-HEADEREND:event_dout3ItemStateChanged
  handleLamp(evt, 3);
}//GEN-LAST:event_dout3ItemStateChanged

private void fwd1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fwd1ActionPerformed
{//GEN-HEADEREND:event_fwd1ActionPerformed
  startMotor(1, true);
}//GEN-LAST:event_fwd1ActionPerformed

private void fwd2ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fwd2ActionPerformed
{//GEN-HEADEREND:event_fwd2ActionPerformed
  startMotor(2, true);
}//GEN-LAST:event_fwd2ActionPerformed

private void fwd3ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fwd3ActionPerformed
{//GEN-HEADEREND:event_fwd3ActionPerformed
  startMotor(3, true);
}//GEN-LAST:event_fwd3ActionPerformed

private void fwd4ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fwd4ActionPerformed
{//GEN-HEADEREND:event_fwd4ActionPerformed
  startMotor(4, true);
}//GEN-LAST:event_fwd4ActionPerformed

private void back1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_back1ActionPerformed
{//GEN-HEADEREND:event_back1ActionPerformed
  startMotor(1, false);
}//GEN-LAST:event_back1ActionPerformed

private void stop1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_stop1ActionPerformed
{//GEN-HEADEREND:event_stop1ActionPerformed
  motors[0].stop();
  mStatus[0].setText("Stopped");
}//GEN-LAST:event_stop1ActionPerformed

private void back2ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_back2ActionPerformed
{//GEN-HEADEREND:event_back2ActionPerformed
  startMotor(2, false);
}//GEN-LAST:event_back2ActionPerformed

private void stop2ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_stop2ActionPerformed
{//GEN-HEADEREND:event_stop2ActionPerformed
  motors[1].stop();
  mStatus[1].setText("Stopped");
}//GEN-LAST:event_stop2ActionPerformed

private void back3ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_back3ActionPerformed
{//GEN-HEADEREND:event_back3ActionPerformed
  startMotor(3, false);
}//GEN-LAST:event_back3ActionPerformed

private void stop3ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_stop3ActionPerformed
{//GEN-HEADEREND:event_stop3ActionPerformed
  motors[2].stop();
  mStatus[2].setText("Stopped");
}//GEN-LAST:event_stop3ActionPerformed

private void back4ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_back4ActionPerformed
{//GEN-HEADEREND:event_back4ActionPerformed
  startMotor(4, false);
}//GEN-LAST:event_back4ActionPerformed

private void stop4ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_stop4ActionPerformed
{//GEN-HEADEREND:event_stop4ActionPerformed
  motors[3].stop();
  mStatus[3].setText("Stopped");
}//GEN-LAST:event_stop4ActionPerformed

private void cb1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cb1ActionPerformed
{//GEN-HEADEREND:event_cb1ActionPerformed
  setCounter(1);
}//GEN-LAST:event_cb1ActionPerformed

private void cb2ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cb2ActionPerformed
{//GEN-HEADEREND:event_cb2ActionPerformed
  setCounter(2);
}//GEN-LAST:event_cb2ActionPerformed

private void cb3ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cb3ActionPerformed
{//GEN-HEADEREND:event_cb3ActionPerformed
  setCounter(3);
}//GEN-LAST:event_cb3ActionPerformed

private void cb4ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cb4ActionPerformed
{//GEN-HEADEREND:event_cb4ActionPerformed
  setCounter(4);
}//GEN-LAST:event_cb4ActionPerformed

private void cb5ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cb5ActionPerformed
{//GEN-HEADEREND:event_cb5ActionPerformed
  setCounter(5);
}//GEN-LAST:event_cb5ActionPerformed

private void cb6ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cb6ActionPerformed
{//GEN-HEADEREND:event_cb6ActionPerformed
  setCounter(6);
}//GEN-LAST:event_cb6ActionPerformed

private void cb7ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cb7ActionPerformed
{//GEN-HEADEREND:event_cb7ActionPerformed
  setCounter(7);
}//GEN-LAST:event_cb7ActionPerformed

private void cb8ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cb8ActionPerformed
{//GEN-HEADEREND:event_cb8ActionPerformed
  setCounter(8);
}//GEN-LAST:event_cb8ActionPerformed

private void count2ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_count2ActionPerformed
{//GEN-HEADEREND:event_count2ActionPerformed
  // TODO add your handling code here:
}//GEN-LAST:event_count2ActionPerformed

  private void setCounter(int counterNb)
  {
    int counterIndex = counterNb - 1;

    int count = 0;
    try
    {
      count = Integer.parseInt(counterValues[counterIndex].getText());
    }
    catch (NumberFormatException ex)
    {
      count = 0;
      counterValues[counterIndex].setText("0");
    }
    if (count < 0)
    {
      count = 0;
      counterValues[counterIndex].setText("0");
    }

    counters[counterIndex].setCount(count);
  }

  private void handleLamp(ItemEvent evt, int lampNb)
  {
    int lampIndex = lampNb - 1;
    if (evt.getStateChange() == ItemEvent.DESELECTED)
      lamps[lampIndex].off();
    else
    {
      int intensity;
      try
      {
        intensity = Integer.parseInt(lampz[lampIndex].getText());
      }
      catch (NumberFormatException ex)
      {
        intensity = 8;
        lampz[lampIndex].setText("8");
      }
      if (intensity < 1)
      {
        intensity = 1;
        lampz[lampIndex].setText("1");
      }
      if (intensity > 8)
      {
        intensity = 8;
        lampz[lampIndex].setText("8");
      }
      lamps[lampIndex].setIntensity(intensity);
      lamps[lampIndex].on();
    }
  }

  private void startMotor(int motorNb, boolean isForward)
  {
    isRoboMode = false;
    int motorIndex = motorNb - 1;

    int speed;
    try
    {
      speed = Integer.parseInt(mSpeeds[motorIndex].getText());
    }
    catch (NumberFormatException ex)
    {
      speed = 8;
      mSpeeds[motorIndex].setText("8");
    }
    if (speed < 1)
    {
      speed = 1;
      mSpeeds[motorIndex].setText("1");
    }
    if (speed > 8)
    {
      speed = 8;
      mSpeeds[motorIndex].setText("8");
    }

    int steps;
    try
    {
      steps = Integer.parseInt(mSteps[motorIndex].getText());
    }
    catch (NumberFormatException ex)
    {
      steps = 0;
      mSteps[motorIndex].setText("0");
    }
    if (steps < 0)
    {
      steps = 0;
      mSteps[motorIndex].setText("0");
    }

    motors[motorIndex].setSpeed(speed);
    if (steps == 0)
    {
      if (isForward)
      {
        motors[motorIndex].right();
        mStatus[motorIndex].setText("Running right");
      }
      else
      {
        motors[motorIndex].left();
        mStatus[motorIndex].setText("Running left");
      }
    }
    else
    {
      isRoboMode = true;
      if (isForward)
        motors[motorIndex].right(steps);
      else
        motors[motorIndex].left(steps);
    }
  }

  private void doConnect(boolean start)
  {
    boolean rc = fc.connect();
    if (!rc)
    {
      connectField.setBackground(Color.red);
      if (start)
        connectionBtn.setEnabled(true);
      else
      {
        JOptionPane.showMessageDialog(null, "Connection to the controller failed.\n" +
          "Check USB cable and power supply.\n" +
          "Then press the 'Connect' button",
          "Fatal error",
          JOptionPane.ERROR_MESSAGE);
      }
    }
    else
    {
      connectionBtn.setEnabled(false);
      connectionLabel.setText("Connection established");
      String deviceType = Integer.toString(fc.getDeviceType());
      String serialNumber = Integer.toString(fc.getSerialNumber());
      String firmwareInfo = fc.getFirmwareInfo();
      controllerInfo.setText("Controller info: " +
        deviceType + "/" +
        serialNumber + " V" +
        firmwareInfo);
      connectField.setBackground(Color.green);
      initDigitalIn();
    }
  }

  private void cleanup()
  {
    fc.dispose();
    System.exit(0);
  }

  protected void processWindowEvent(WindowEvent e)
  {
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      cleanup();
    else
      super.processWindowEvent(e);
  }

  public void connectionLost()
  {
    connectField.setBackground(Color.red);
    connectionLabel.setText("Connection lost. Restart program");
  }

  public void digitalChanged(DigitalEvent evt)
  {
    for (int portNb = 1; portNb <= 8; portNb++)
    {
      if (evt.isPortChanged(portNb))
      {
        if (evt.isPortOn(portNb))
          digitalIn[portNb - 1].setBackground(Color.green);
        else
          digitalIn[portNb - 1].setBackground(Color.red);
      }
    }
  }

  public void analogChanged(AnalogEvent evt)
  {
    if (evt.getPort() == 1)
      a1.setText(Integer.toString(evt.getValue()));
    if (evt.getPort() == 2)
      a2.setText(Integer.toString(evt.getValue()));
  }

  public void resistorChanged(ResistorEvent evt)
  {
    if (evt.getPort() == 1)
      ax.setText(Integer.toString(evt.getValue()));
    if (evt.getPort() == 2)
      ay.setText(Integer.toString(evt.getValue()));
  }

  public void distanceChanged(DistanceEvent evt)
  {
    if (evt.getPort() == 1)
      d1.setText(Integer.toString(evt.getDistance()));
    if (evt.getPort() == 2)
      d2.setText(Integer.toString(evt.getDistance()));
  }

  public void countChanged(CounterEvent evt)
  {
    int nb = evt.getCounterNb();
    int value = evt.getCount();
    counterValues[nb - 1].setText(Integer.toString(value));
  }

  public void motorStopped(int motorNb, boolean isEnd)
  {
    if (isRoboMode)
    {
      if (isEnd)
        mStatus[motorNb - 1].setText("End switch stop");
      else
        mStatus[motorNb - 1].setText("Steps reached");
    }
  }

  public void stepChanged(int motorNb, int step)
  {
    if (isRoboMode)
      mStatus[motorNb - 1].setText("# steps: " + step);
  }

  private int getJitterValue(int choice)
  {
    int value = 0;
    try
    {
      value = Integer.parseInt(jitters[choice].getText());
      if (value < 0 || value > 1000)
        throw (new IllegalArgumentException());
    }
    catch (IllegalArgumentException ex)
    {
      jitters[choice].setText("0");
    }

    return value;
  }

  private void initDigitalIn()
  {
    int value = fc.digitalIn.getValue();
    int mask = 1;
    for (int portNb = 1; portNb <= 8; portNb++)
    {
      if ((value & mask) != 0)
        digitalIn[portNb - 1].setBackground(Color.green);
      else
        digitalIn[portNb - 1].setBackground(Color.red);
      mask *= 2;
    }
  }

  /**
   * @param args the command line arguments
   */
  public static void main(String args[])
  {
    try
    {
      UIManager.setLookAndFeel(
        UIManager.getSystemLookAndFeelClassName());
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }


    java.awt.EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        new FtCommand().setVisible(true);
      }
    });
  }
  // Instance variables
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JTextField a1;
  private javax.swing.JTextField a1jitter;
  private javax.swing.JTextField a2;
  private javax.swing.JTextField a2jitter;
  private javax.swing.JTextField ax;
  private javax.swing.JTextField axjitter;
  private javax.swing.JTextField ay;
  private javax.swing.JTextField ayjitter;
  private javax.swing.JButton back1;
  private javax.swing.JButton back2;
  private javax.swing.JButton back3;
  private javax.swing.JButton back4;
  private javax.swing.JButton cb1;
  private javax.swing.JButton cb2;
  private javax.swing.JButton cb3;
  private javax.swing.JButton cb4;
  private javax.swing.JButton cb5;
  private javax.swing.JButton cb6;
  private javax.swing.JButton cb7;
  private javax.swing.JButton cb8;
  private javax.swing.JTextField connectField;
  private javax.swing.JButton connectionBtn;
  private javax.swing.JLabel connectionLabel;
  private javax.swing.JLabel controllerInfo;
  private javax.swing.JTextField count1;
  private javax.swing.JTextField count2;
  private javax.swing.JTextField count3;
  private javax.swing.JTextField count4;
  private javax.swing.JTextField count5;
  private javax.swing.JTextField count6;
  private javax.swing.JTextField count7;
  private javax.swing.JTextField count8;
  private javax.swing.JTextField d1;
  private javax.swing.JTextField d2;
  private javax.swing.JTextField din1;
  private javax.swing.JTextField din2;
  private javax.swing.JTextField din3;
  private javax.swing.JTextField din4;
  private javax.swing.JTextField din5;
  private javax.swing.JTextField din6;
  private javax.swing.JTextField din7;
  private javax.swing.JTextField din8;
  private javax.swing.JCheckBox dout1;
  private javax.swing.JCheckBox dout2;
  private javax.swing.JCheckBox dout3;
  private javax.swing.JCheckBox dout4;
  private javax.swing.JCheckBox dout5;
  private javax.swing.JCheckBox dout6;
  private javax.swing.JCheckBox dout7;
  private javax.swing.JCheckBox dout8;
  private javax.swing.JTextField dval1;
  private javax.swing.JTextField dval2;
  private javax.swing.JTextField dval3;
  private javax.swing.JTextField dval4;
  private javax.swing.JTextField dval5;
  private javax.swing.JTextField dval6;
  private javax.swing.JTextField dval7;
  private javax.swing.JTextField dval8;
  private javax.swing.JButton fwd1;
  private javax.swing.JButton fwd2;
  private javax.swing.JButton fwd3;
  private javax.swing.JButton fwd4;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel10;
  private javax.swing.JLabel jLabel11;
  private javax.swing.JLabel jLabel12;
  private javax.swing.JLabel jLabel13;
  private javax.swing.JLabel jLabel14;
  private javax.swing.JLabel jLabel15;
  private javax.swing.JLabel jLabel16;
  private javax.swing.JLabel jLabel17;
  private javax.swing.JLabel jLabel18;
  private javax.swing.JLabel jLabel19;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JLabel jLabel20;
  private javax.swing.JLabel jLabel21;
  private javax.swing.JLabel jLabel22;
  private javax.swing.JLabel jLabel23;
  private javax.swing.JLabel jLabel24;
  private javax.swing.JLabel jLabel25;
  private javax.swing.JLabel jLabel26;
  private javax.swing.JLabel jLabel27;
  private javax.swing.JLabel jLabel28;
  private javax.swing.JLabel jLabel29;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JLabel jLabel30;
  private javax.swing.JLabel jLabel31;
  private javax.swing.JLabel jLabel32;
  private javax.swing.JLabel jLabel33;
  private javax.swing.JLabel jLabel34;
  private javax.swing.JLabel jLabel35;
  private javax.swing.JLabel jLabel36;
  private javax.swing.JLabel jLabel37;
  private javax.swing.JLabel jLabel38;
  private javax.swing.JLabel jLabel39;
  private javax.swing.JLabel jLabel4;
  private javax.swing.JLabel jLabel40;
  private javax.swing.JLabel jLabel41;
  private javax.swing.JLabel jLabel42;
  private javax.swing.JLabel jLabel43;
  private javax.swing.JLabel jLabel44;
  private javax.swing.JLabel jLabel45;
  private javax.swing.JLabel jLabel46;
  private javax.swing.JLabel jLabel47;
  private javax.swing.JLabel jLabel48;
  private javax.swing.JLabel jLabel5;
  private javax.swing.JLabel jLabel6;
  private javax.swing.JLabel jLabel7;
  private javax.swing.JLabel jLabel8;
  private javax.swing.JLabel jLabel9;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel10;
  private javax.swing.JPanel jPanel11;
  private javax.swing.JPanel jPanel12;
  private javax.swing.JPanel jPanel13;
  private javax.swing.JPanel jPanel14;
  private javax.swing.JPanel jPanel15;
  private javax.swing.JPanel jPanel16;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JPanel jPanel6;
  private javax.swing.JPanel jPanel7;
  private javax.swing.JPanel jPanel8;
  private javax.swing.JPanel jPanel9;
  private javax.swing.JLabel motor1Status;
  private javax.swing.JLabel motor2Status;
  private javax.swing.JLabel motor3Status;
  private javax.swing.JLabel motor4Status;
  private javax.swing.JTextField mspeed1;
  private javax.swing.JTextField mspeed2;
  private javax.swing.JTextField mspeed3;
  private javax.swing.JTextField mspeed4;
  private javax.swing.JTextField msteps1;
  private javax.swing.JTextField msteps2;
  private javax.swing.JTextField msteps3;
  private javax.swing.JTextField msteps4;
  private javax.swing.JButton quitBtn;
  private javax.swing.JButton stop1;
  private javax.swing.JButton stop2;
  private javax.swing.JButton stop3;
  private javax.swing.JButton stop4;
  // End of variables declaration//GEN-END:variables
  private FtController fc;
  private JTextField[] digitalIn = new JTextField[8];
  private Lamp[] lamps = new Lamp[8];
  private JTextField[] lampz = new JTextField[8];
  private Motor[] motors = new Motor[4];
  private boolean isRoboMode;
  private JLabel[] mStatus = new JLabel[4];
  private JTextField[] mSpeeds = new JTextField[4];
  private JTextField[] mSteps = new JTextField[4];
  private Counter[] counters = new Counter[8];
  private JTextField[] counterValues = new JTextField[8];
  private JButton[] counterButtons = new JButton[8];
  private JTextField[] jitters = new JTextField[4];
  private int[] jitterValues = new int[4];
}