// FtLearningRobot.java

import java.awt.*;
import ch.aplu.ftcontroller.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class FtLearningRobot extends javax.swing.JFrame
  implements DigitalListener, ConnectionListener, MotorListener
{
  public FtLearningRobot()
  {
    initComponents();
    initPanel();
    doConnect(true);
  }

  private void initPanel()
  {
    fc = new FtController(false);
    fc.addDigitalListener(this);
    fc.addConnectionListener(this);
    for (int i = 1; i <= 4; i++)
      fc.addMotorListener(this, i);
    digitalIn[0] = din1;
    digitalIn[1] = din2;
    digitalIn[2] = din3;
    digitalIn[3] = din4;
    digitalIn[4] = din5;
    digitalIn[5] = din6;
    digitalIn[6] = din7;
    digitalIn[7] = din8;
    motors[0] = fc.motor1;
    motors[1] = fc.motor2;
    motors[2] = fc.motor3;
    motors[3] = fc.motor4;
    mSpeeds[0] = motor1Speed;
    mSpeeds[1] = motor2Speed;
    mSpeeds[2] = motor3Speed;
    mSpeeds[3] = motor4Speed;
    mSteps[0] = motor1Step;
    mSteps[1] = motor2Step;
    mSteps[2] = motor3Step;
    mSteps[3] = motor4Step;
    mStatus[0] = motor1Status;
    mStatus[1] = motor2Status;
    mStatus[2] = motor3Status;
    mStatus[3] = motor4Status;
    mPos[0] = motor1Pos;
    mPos[1] = motor2Pos;
    mPos[2] = motor3Pos;
    mPos[3] = motor4Pos;
    connectionBtn.setEnabled(false);
    for (int i = 0; i < 8; i++)
    {
      digitalIn[i].setEditable(false);
      digitalIn[i].setBackground(Color.red);
    }
    for (int i = 0; i < 4; i++)
      mState[i] = MotorState.STOP;
    for (int i = 0; i < 4; i++)
      mPositionOld[i] = mPositionCurrent[i] = 0;
    connectField.setEditable(false);
    connectField.setBackground(Color.red);
    setTitle("Fischertechnik Learning Robot " + version + " (www.aplu.ch)");
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPanel11 = new javax.swing.JPanel();
    connectionLabel = new javax.swing.JLabel();
    controllerInfo = new javax.swing.JLabel();
    connectionBtn = new javax.swing.JButton();
    connectField = new javax.swing.JTextField();
    jPanel6 = new javax.swing.JPanel();
    fwd1 = new javax.swing.JButton();
    back1 = new javax.swing.JButton();
    motor1Speed = new javax.swing.JTextField();
    jLabel23 = new javax.swing.JLabel();
    motor1Step = new javax.swing.JTextField();
    din1 = new javax.swing.JTextField();
    din2 = new javax.swing.JTextField();
    motor1Pos = new javax.swing.JTextField();
    go1 = new javax.swing.JButton();
    jLabel13 = new javax.swing.JLabel();
    jLabel24 = new javax.swing.JLabel();
    jLabel25 = new javax.swing.JLabel();
    jLabel26 = new javax.swing.JLabel();
    motor1Status = new javax.swing.JTextField();
    jLabel14 = new javax.swing.JLabel();
    jPanel7 = new javax.swing.JPanel();
    fwd4 = new javax.swing.JButton();
    back4 = new javax.swing.JButton();
    motor4Speed = new javax.swing.JTextField();
    jLabel27 = new javax.swing.JLabel();
    motor4Step = new javax.swing.JTextField();
    din7 = new javax.swing.JTextField();
    din8 = new javax.swing.JTextField();
    motor4Pos = new javax.swing.JTextField();
    go4 = new javax.swing.JButton();
    jLabel15 = new javax.swing.JLabel();
    jLabel28 = new javax.swing.JLabel();
    jLabel29 = new javax.swing.JLabel();
    jLabel30 = new javax.swing.JLabel();
    motor4Status = new javax.swing.JTextField();
    jLabel16 = new javax.swing.JLabel();
    jPanel8 = new javax.swing.JPanel();
    fwd3 = new javax.swing.JButton();
    back3 = new javax.swing.JButton();
    motor3Speed = new javax.swing.JTextField();
    jLabel31 = new javax.swing.JLabel();
    motor3Step = new javax.swing.JTextField();
    din5 = new javax.swing.JTextField();
    din6 = new javax.swing.JTextField();
    motor3Pos = new javax.swing.JTextField();
    go3 = new javax.swing.JButton();
    jLabel17 = new javax.swing.JLabel();
    jLabel32 = new javax.swing.JLabel();
    jLabel33 = new javax.swing.JLabel();
    jLabel34 = new javax.swing.JLabel();
    motor3Status = new javax.swing.JTextField();
    jLabel18 = new javax.swing.JLabel();
    jPanel9 = new javax.swing.JPanel();
    fwd2 = new javax.swing.JButton();
    back2 = new javax.swing.JButton();
    motor2Speed = new javax.swing.JTextField();
    jLabel35 = new javax.swing.JLabel();
    motor2Step = new javax.swing.JTextField();
    din3 = new javax.swing.JTextField();
    din4 = new javax.swing.JTextField();
    motor2Pos = new javax.swing.JTextField();
    go2 = new javax.swing.JButton();
    jLabel19 = new javax.swing.JLabel();
    jLabel36 = new javax.swing.JLabel();
    jLabel37 = new javax.swing.JLabel();
    jLabel38 = new javax.swing.JLabel();
    motor2Status = new javax.swing.JTextField();
    jLabel20 = new javax.swing.JLabel();
    jPanel1 = new javax.swing.JPanel();
    quitBtn = new javax.swing.JButton();
    runBtn = new javax.swing.JButton();
    repeatBtn = new javax.swing.JButton();
    saveBtn = new javax.swing.JButton();
    allHomeBtn = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    setResizable(false);

    jPanel11.setBorder(javax.swing.BorderFactory.createTitledBorder("Connection Status"));

    connectionLabel.setText("Not connected");

    controllerInfo.setText("(no controller info)");

    connectionBtn.setText("Connect");
    connectionBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        connectionBtnActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout jPanel11Layout = new javax.swing.GroupLayout(jPanel11);
    jPanel11.setLayout(jPanel11Layout);
    jPanel11Layout.setHorizontalGroup(
      jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel11Layout.createSequentialGroup()
        .addContainerGap()
        .addComponent(connectField, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addGap(16, 16, 16)
        .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
          .addComponent(controllerInfo, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(connectionLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(connectionBtn)
        .addContainerGap(4, Short.MAX_VALUE))
    );
    jPanel11Layout.setVerticalGroup(
      jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel11Layout.createSequentialGroup()
        .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(connectionLabel)
          .addComponent(connectionBtn)
          .addComponent(connectField, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(controllerInfo))
    );

    jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder("Rotation"));

    fwd1.setText("Right");
    fwd1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        fwd1ActionPerformed(evt);
      }
    });

    back1.setText("Left");
    back1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        back1ActionPerformed(evt);
      }
    });

    motor1Speed.setBackground(new java.awt.Color(204, 255, 204));
    motor1Speed.setColumns(3);
    motor1Speed.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    motor1Speed.setText("3");

    jLabel23.setText("Speed:");

    motor1Step.setColumns(6);
    motor1Step.setEditable(false);
    motor1Step.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

    din2.setVerifyInputWhenFocusTarget(false);

    motor1Pos.setBackground(new java.awt.Color(204, 255, 204));
    motor1Pos.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    motor1Pos.setText("0");

    go1.setText("Go");
    go1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        go1ActionPerformed(evt);
      }
    });

    jLabel13.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel13.setText("To:");

    jLabel24.setText("I1:");

    jLabel25.setText("I2:");

    jLabel26.setText("Status:");

    motor1Status.setEditable(false);
    motor1Status.setHorizontalAlignment(javax.swing.JTextField.LEFT);

    jLabel14.setText("Now:");

    javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
    jPanel6.setLayout(jPanel6Layout);
    jPanel6Layout.setHorizontalGroup(
      jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel6Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(jPanel6Layout.createSequentialGroup()
            .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
              .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel6Layout.createSequentialGroup()
                .addComponent(jLabel23)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(motor1Speed))
              .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel6Layout.createSequentialGroup()
                .addComponent(jLabel26)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(motor1Status, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)))
            .addContainerGap(23, Short.MAX_VALUE))
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
            .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addComponent(back1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 125, Short.MAX_VALUE)
              .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                .addComponent(fwd1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel6Layout.createSequentialGroup()
                  .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(motor1Step, javax.swing.GroupLayout.DEFAULT_SIZE, 25, Short.MAX_VALUE))
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 12, Short.MAX_VALUE)
                  .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel13, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(motor1Pos, javax.swing.GroupLayout.DEFAULT_SIZE, 28, Short.MAX_VALUE))
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                  .addComponent(go1))))
            .addGap(10, 10, 10))
          .addGroup(jPanel6Layout.createSequentialGroup()
            .addComponent(jLabel24)
            .addGap(5, 5, 5)
            .addComponent(din1, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(31, 31, 31)
            .addComponent(jLabel25)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(din2, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap())))
    );
    jPanel6Layout.setVerticalGroup(
      jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel6Layout.createSequentialGroup()
        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel26)
          .addComponent(motor1Status, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 20, Short.MAX_VALUE)
        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel23)
          .addComponent(motor1Speed, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel13)
          .addComponent(jLabel14))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(motor1Pos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(motor1Step, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(go1))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(fwd1)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(back1)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(din1, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel24)
          .addComponent(din2, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel25))
        .addContainerGap())
    );

    jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder("Grabber"));

    fwd4.setText("Grab");
    fwd4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        fwd4ActionPerformed(evt);
      }
    });

    back4.setText("Release");
    back4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        back4ActionPerformed(evt);
      }
    });

    motor4Speed.setBackground(new java.awt.Color(204, 255, 204));
    motor4Speed.setColumns(3);
    motor4Speed.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    motor4Speed.setText("6");

    jLabel27.setText("Speed:");

    motor4Step.setColumns(6);
    motor4Step.setEditable(false);
    motor4Step.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

    din8.setVerifyInputWhenFocusTarget(false);

    motor4Pos.setBackground(new java.awt.Color(204, 255, 204));
    motor4Pos.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    motor4Pos.setText("0");

    go4.setText("Go");
    go4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        go4ActionPerformed(evt);
      }
    });

    jLabel15.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel15.setText("To:");

    jLabel28.setText("I7:");

    jLabel29.setText("I8:");

    jLabel30.setText("Status:");

    motor4Status.setEditable(false);
    motor4Status.setHorizontalAlignment(javax.swing.JTextField.LEFT);

    jLabel16.setText("Now:");

    javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
    jPanel7.setLayout(jPanel7Layout);
    jPanel7Layout.setHorizontalGroup(
      jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel7Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel7Layout.createSequentialGroup()
              .addComponent(jLabel27)
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
              .addComponent(motor4Speed))
            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel7Layout.createSequentialGroup()
              .addComponent(jLabel30)
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
              .addComponent(motor4Status, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)))
          .addComponent(back4, javax.swing.GroupLayout.DEFAULT_SIZE, 125, Short.MAX_VALUE)
          .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
            .addComponent(fwd4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(jPanel7Layout.createSequentialGroup()
              .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                .addComponent(jLabel16, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(motor4Step, javax.swing.GroupLayout.DEFAULT_SIZE, 25, Short.MAX_VALUE))
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 12, Short.MAX_VALUE)
              .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                .addComponent(jLabel15, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(motor4Pos, javax.swing.GroupLayout.DEFAULT_SIZE, 28, Short.MAX_VALUE))
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
              .addComponent(go4)))
          .addGroup(jPanel7Layout.createSequentialGroup()
            .addComponent(jLabel28)
            .addGap(5, 5, 5)
            .addComponent(din7, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(31, 31, 31)
            .addComponent(jLabel29)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(din8, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)))
        .addContainerGap())
    );
    jPanel7Layout.setVerticalGroup(
      jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel7Layout.createSequentialGroup()
        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel30)
          .addComponent(motor4Status, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 20, Short.MAX_VALUE)
        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel27)
          .addComponent(motor4Speed, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel15)
          .addComponent(jLabel16))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(motor4Pos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(motor4Step, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(go4))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(fwd4)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(back4)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(din7, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel28)
          .addComponent(jLabel29)
          .addComponent(din8, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addContainerGap())
    );

    jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder("Vertical"));

    fwd3.setText("Down");
    fwd3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        fwd3ActionPerformed(evt);
      }
    });

    back3.setText("Up");
    back3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        back3ActionPerformed(evt);
      }
    });

    motor3Speed.setBackground(new java.awt.Color(204, 255, 204));
    motor3Speed.setColumns(3);
    motor3Speed.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    motor3Speed.setText("8");

    jLabel31.setText("Speed:");

    motor3Step.setColumns(6);
    motor3Step.setEditable(false);
    motor3Step.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

    din6.setVerifyInputWhenFocusTarget(false);

    motor3Pos.setBackground(new java.awt.Color(204, 255, 204));
    motor3Pos.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    motor3Pos.setText("0");

    go3.setText("Go");
    go3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        go3ActionPerformed(evt);
      }
    });

    jLabel17.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel17.setText("To:");

    jLabel32.setText("I5:");

    jLabel33.setText("I6:");

    jLabel34.setText("Status:");

    motor3Status.setEditable(false);
    motor3Status.setHorizontalAlignment(javax.swing.JTextField.LEFT);

    jLabel18.setText("Now:");

    javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
    jPanel8.setLayout(jPanel8Layout);
    jPanel8Layout.setHorizontalGroup(
      jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel8Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel8Layout.createSequentialGroup()
              .addComponent(jLabel31)
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
              .addComponent(motor3Speed))
            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel8Layout.createSequentialGroup()
              .addComponent(jLabel34)
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
              .addComponent(motor3Status, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)))
          .addComponent(back3, javax.swing.GroupLayout.DEFAULT_SIZE, 125, Short.MAX_VALUE)
          .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
            .addComponent(fwd3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(jPanel8Layout.createSequentialGroup()
              .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                .addComponent(jLabel18, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(motor3Step, javax.swing.GroupLayout.DEFAULT_SIZE, 25, Short.MAX_VALUE))
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 12, Short.MAX_VALUE)
              .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                .addComponent(jLabel17, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(motor3Pos, javax.swing.GroupLayout.DEFAULT_SIZE, 28, Short.MAX_VALUE))
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
              .addComponent(go3)))
          .addGroup(jPanel8Layout.createSequentialGroup()
            .addComponent(jLabel32)
            .addGap(5, 5, 5)
            .addComponent(din5, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(31, 31, 31)
            .addComponent(jLabel33)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(din6, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)))
        .addContainerGap())
    );
    jPanel8Layout.setVerticalGroup(
      jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel8Layout.createSequentialGroup()
        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel34)
          .addComponent(motor3Status, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 20, Short.MAX_VALUE)
        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel31)
          .addComponent(motor3Speed, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel17)
          .addComponent(jLabel18))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(motor3Pos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(motor3Step, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(go3))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(fwd3)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(back3)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(din5, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jLabel32)
          .addComponent(jLabel33)
          .addComponent(din6, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addContainerGap())
    );

    jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder("Horizontal"));

    fwd2.setText("Forward");
    fwd2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        fwd2ActionPerformed(evt);
      }
    });

    back2.setText("Backward");
    back2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        back2ActionPerformed(evt);
      }
    });

    motor2Speed.setBackground(new java.awt.Color(204, 255, 204));
    motor2Speed.setColumns(3);
    motor2Speed.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    motor2Speed.setText("8");

    jLabel35.setText("Speed:");

    motor2Step.setColumns(6);
    motor2Step.setEditable(false);
    motor2Step.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

    din4.setVerifyInputWhenFocusTarget(false);

    motor2Pos.setBackground(new java.awt.Color(204, 255, 204));
    motor2Pos.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
    motor2Pos.setText("0");

    go2.setText("Go");
    go2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        go2ActionPerformed(evt);
      }
    });

    jLabel19.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel19.setText("To:");

    jLabel36.setText("I3:");

    jLabel37.setText("I4:");

    jLabel38.setText("Status:");

    motor2Status.setEditable(false);
    motor2Status.setHorizontalAlignment(javax.swing.JTextField.LEFT);

    jLabel20.setText("Now:");

    javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
    jPanel9.setLayout(jPanel9Layout);
    jPanel9Layout.setHorizontalGroup(
      jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel9Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel9Layout.createSequentialGroup()
              .addComponent(jLabel35)
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
              .addComponent(motor2Speed))
            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel9Layout.createSequentialGroup()
              .addComponent(jLabel38)
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
              .addComponent(motor2Status, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)))
          .addComponent(back2, javax.swing.GroupLayout.DEFAULT_SIZE, 125, Short.MAX_VALUE)
          .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
            .addComponent(fwd2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(jPanel9Layout.createSequentialGroup()
              .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                .addComponent(jLabel20, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(motor2Step, javax.swing.GroupLayout.DEFAULT_SIZE, 25, Short.MAX_VALUE))
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 12, Short.MAX_VALUE)
              .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                .addComponent(jLabel19, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(motor2Pos, javax.swing.GroupLayout.DEFAULT_SIZE, 28, Short.MAX_VALUE))
              .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
              .addComponent(go2)))
          .addGroup(jPanel9Layout.createSequentialGroup()
            .addComponent(jLabel36)
            .addGap(5, 5, 5)
            .addComponent(din3, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(31, 31, 31)
            .addComponent(jLabel37)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(din4, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)))
        .addContainerGap())
    );
    jPanel9Layout.setVerticalGroup(
      jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel9Layout.createSequentialGroup()
        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel38)
          .addComponent(motor2Status, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 20, Short.MAX_VALUE)
        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel35)
          .addComponent(motor2Speed, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel19)
          .addComponent(jLabel20))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(motor2Pos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(motor2Step, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(go2))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(fwd2)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(back2)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(jLabel36)
          .addComponent(jLabel37)
          .addComponent(din4, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(din3, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addContainerGap())
    );

    quitBtn.setText("Quit");
    quitBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        quitButtonActionPerformed(evt);
      }
    });

    runBtn.setText("Run");
    runBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        runBtnActionPerformed(evt);
      }
    });

    repeatBtn.setText("Repeat");
    repeatBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        repeatBtnActionPerformed(evt);
      }
    });

    saveBtn.setText("Save");
    saveBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        saveBtnActionPerformed(evt);
      }
    });

    allHomeBtn.setText("All Home");
    allHomeBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        allHomeBtnActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
    jPanel1.setLayout(jPanel1Layout);
    jPanel1Layout.setHorizontalGroup(
      jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel1Layout.createSequentialGroup()
        .addGap(22, 22, 22)
        .addComponent(runBtn, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(jPanel1Layout.createSequentialGroup()
            .addComponent(allHomeBtn)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(quitBtn))
          .addGroup(jPanel1Layout.createSequentialGroup()
            .addComponent(repeatBtn, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(saveBtn)))
        .addContainerGap(58, Short.MAX_VALUE))
    );

    jPanel1Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {allHomeBtn, quitBtn, repeatBtn, saveBtn});

    jPanel1Layout.setVerticalGroup(
      jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(jPanel1Layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(repeatBtn)
          .addComponent(saveBtn)
          .addComponent(runBtn))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(allHomeBtn)
          .addComponent(quitBtn))
        .addContainerGap())
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
    getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
            .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
            .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
            .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
            .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
          .addGroup(layout.createSequentialGroup()
            .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, 347, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        .addContainerGap(16, Short.MAX_VALUE))
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addComponent(jPanel6, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jPanel9, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(jPanel8, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(jPanel7, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    );

    pack();
  }// </editor-fold>//GEN-END:initComponents

private void quitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_quitButtonActionPerformed
  connectField.setBackground(Color.red);
  cleanup();
}//GEN-LAST:event_quitButtonActionPerformed

private void connectionBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_connectionBtnActionPerformed
{//GEN-HEADEREND:event_connectionBtnActionPerformed
  doConnect(false);
}//GEN-LAST:event_connectionBtnActionPerformed

private void fwd1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fwd1ActionPerformed
{//GEN-HEADEREND:event_fwd1ActionPerformed
  forwardAction(0);
}//GEN-LAST:event_fwd1ActionPerformed

private void back1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_back1ActionPerformed
{//GEN-HEADEREND:event_back1ActionPerformed
  backAction(0);
}//GEN-LAST:event_back1ActionPerformed

private void allHomeBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_allHomeBtnActionPerformed
{//GEN-HEADEREND:event_allHomeBtnActionPerformed
  if (isRunning)
    return;
  for (int motorIndex = 0; motorIndex < 4; motorIndex++)
  {
    mSpeeds[motorIndex].setText("8");
    if (!atHome[motorIndex])
    {
      mDirection[motorIndex] = false;
      startMotor(motorIndex);
    }
  }
}//GEN-LAST:event_allHomeBtnActionPerformed

private void go1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_go1ActionPerformed
{//GEN-HEADEREND:event_go1ActionPerformed
  int pos;
  try
  {
    pos = Integer.parseInt(mPos[0].getText());
  }
  catch (NumberFormatException ex)
  {
    return;
  }
  int speed;
  try
  {
    speed = Integer.parseInt(mSpeeds[0].getText());
  }
  catch (NumberFormatException ex)
  {
    return;
  }
  moveTo(0, speed, pos);
}//GEN-LAST:event_go1ActionPerformed

private void fwd4ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fwd4ActionPerformed
{//GEN-HEADEREND:event_fwd4ActionPerformed
  forwardAction(3);
}//GEN-LAST:event_fwd4ActionPerformed

private void back4ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_back4ActionPerformed
{//GEN-HEADEREND:event_back4ActionPerformed
  backAction(3);
}//GEN-LAST:event_back4ActionPerformed

private void go4ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_go4ActionPerformed
{//GEN-HEADEREND:event_go4ActionPerformed
  int pos;
  try
  {
    pos = Integer.parseInt(mPos[3].getText());
  }
  catch (NumberFormatException ex)
  {
    return;
  }
  int speed;
  try
  {
    speed = Integer.parseInt(mSpeeds[3].getText());
  }
  catch (NumberFormatException ex)
  {
    return;
  }
  moveTo(3, speed, pos);
}//GEN-LAST:event_go4ActionPerformed

private void fwd3ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fwd3ActionPerformed
{//GEN-HEADEREND:event_fwd3ActionPerformed
  forwardAction(2);
}//GEN-LAST:event_fwd3ActionPerformed

private void back3ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_back3ActionPerformed
{//GEN-HEADEREND:event_back3ActionPerformed
  backAction(2);
}//GEN-LAST:event_back3ActionPerformed

private void go3ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_go3ActionPerformed
{//GEN-HEADEREND:event_go3ActionPerformed
  int pos;
  try
  {
    pos = Integer.parseInt(mPos[2].getText());
  }
  catch (NumberFormatException ex)
  {
    return;
  }
  int speed;
  try
  {
    speed = Integer.parseInt(mSpeeds[2].getText());
  }
  catch (NumberFormatException ex)
  {
    return;
  }
  moveTo(2, speed, pos);
}//GEN-LAST:event_go3ActionPerformed

private void fwd2ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fwd2ActionPerformed
{//GEN-HEADEREND:event_fwd2ActionPerformed
  forwardAction(1);
}//GEN-LAST:event_fwd2ActionPerformed

private void back2ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_back2ActionPerformed
{//GEN-HEADEREND:event_back2ActionPerformed
  backAction(1);
}//GEN-LAST:event_back2ActionPerformed

private void go2ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_go2ActionPerformed
{//GEN-HEADEREND:event_go2ActionPerformed
  int pos;
  try
  {
    pos = Integer.parseInt(mPos[1].getText());
  }
  catch (NumberFormatException ex)
  {
    return;
  }
  int speed;
  try
  {
    speed = Integer.parseInt(mSpeeds[1].getText());
  }
  catch (NumberFormatException ex)
  {
    return;
  }
  moveTo(1, speed, pos);
}//GEN-LAST:event_go2ActionPerformed

private void saveBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_saveBtnActionPerformed
{//GEN-HEADEREND:event_saveBtnActionPerformed
  for (int motorIndex = 0; motorIndex < 4; motorIndex++)
    if (mSteps[motorIndex].getText().trim().equals(""))
      return;

  File file = new File(filename);
  if (ra == null && file.exists())
  {
    int rc = JOptionPane.showConfirmDialog(null,
      "File " + filename + " already exits.\nAre you sure to replace it?",
      "Warning", JOptionPane.YES_NO_OPTION);
    if (rc == JOptionPane.NO_OPTION)
      return;
  }

  Dimension size = requestSize();
  if (ra != null)
    ra.dispose();
  ra = new RunArea(myApp, size.width);

  if (sb == null)
    sb = new StringBuffer();

  try
  {
    if (out == null && file.isFile())
      file.delete();
    out = new PrintWriter(new BufferedWriter(new FileWriter(file, true)));
    out.print(nbPos + ": ");
    sb.append(nbPos + ": ");
    nbPos++;
    for (int motorIndex = 0; motorIndex < 4; motorIndex++)
    {
      String line = mSpeeds[motorIndex].getText() + "," +
        mSteps[motorIndex].getText();
      out.print(line);
      sb.append(line);
      if (motorIndex < 3)
      {
        out.print("; ");
        sb.append("; ");
      }
      else
      {
        out.println();
        sb.append("\n");
      }
    }
    if (out != null)
      out.close();
    ra.insert(sb.toString());
  }
  catch (Exception ex)
  {
    JOptionPane.showMessageDialog(null, "Can't write to\n" + filename);
  }

}//GEN-LAST:event_saveBtnActionPerformed

private void runBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_runBtnActionPerformed
{//GEN-HEADEREND:event_runBtnActionPerformed
  if (isRunning)
  {
    allHome = false;
    isRunning = false;
    return;
  }
  if (allHome)
  {
    isRunning = true;
    runBtn.setText("Stop");
    new Executor().start();
  }
  else
    JOptionPane.showMessageDialog(null, "Must start from home position");

}//GEN-LAST:event_runBtnActionPerformed

private void repeatBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_repeatBtnActionPerformed
{//GEN-HEADEREND:event_repeatBtnActionPerformed
  if (isRunning)
    return;
  isRepeating = true;
  runBtnActionPerformed(null);
}//GEN-LAST:event_repeatBtnActionPerformed

  private void forwardAction(int motorIndex)
  {
    if (mState[motorIndex] == MotorState.FORWARD)
    {
      stopAction(motorIndex);
      return;
    }
    mState[motorIndex] = MotorState.FORWARD;
    allHomeEnabled = false;
    mDirection[motorIndex] = true;
    startMotor(motorIndex);
    setBtnFwdText(motorIndex);
  }

  private void backAction(int motorIndex)
  {
    if (atHome[motorIndex])
      return;
    if (mState[motorIndex] == MotorState.BACK)
    {
      stopAction(motorIndex);
      return;
    }
    mState[motorIndex] = MotorState.BACK;
    allHomeEnabled = false;
    mDirection[motorIndex] = false;
    startMotor(motorIndex);
    setBtnBackText(motorIndex);
  }

  private void stopAction(int motorIndex)
  {
    if (atHome[motorIndex])
      return;
    setBtnText(motorIndex);
    mState[motorIndex] = MotorState.STOP;
    motors[motorIndex].stop();
    mPositionOld[motorIndex] = mPositionCurrent[motorIndex];
    showStatus(motorIndex, "Stopped");
    allHome = false;
    allHomeEnabled = true;
  }

  private void moveTo(final int motorIndex, final int speed, final int position)
  // Does not block
  {
 //   System.out.println("moveTo(" + motorIndex + ", " + speed + ", " + position + ")");
    if (position < 0)
      return;

    final int steps = position - mPositionOld[motorIndex];
 //   System.out.println("Steps: " + steps);
    if (steps == 0)
    {
      mState[motorIndex] = MotorState.STOP;
      return;
    }

    motors[motorIndex].setSpeed(speed);
    allHomeEnabled = true;


    if (steps > 0)
    {
      mDirection[motorIndex] = true;
      showStatus(motorIndex, "Count up");
      atHome[motorIndex] = false;
      mState[motorIndex] = MotorState.FORWARD;
      motors[motorIndex].right(steps);
    }
    if (steps < 0)
    {
      mDirection[motorIndex] = false;
      showStatus(motorIndex, "Count down");
      atHome[motorIndex] = false;
      mState[motorIndex] = MotorState.BACK;
      motors[motorIndex].left(-steps);
    }
  }

  private void startMotor(int motorIndex)
  {
    mPositionOld[motorIndex] = mPositionCurrent[motorIndex];

    int speed;
    try
    {
      speed = Integer.parseInt(mSpeeds[motorIndex].getText());
    }
    catch (NumberFormatException ex)
    {
      speed = 8;
      mSpeeds[motorIndex].setText("8");
    }
    if (speed < 1)
    {
      speed = 1;
      mSpeeds[motorIndex].setText("1");
    }
    if (speed > 8)
    {
      speed = 8;
      mSpeeds[motorIndex].setText("8");
    }

    int steps = 10000;

    motors[motorIndex].setSpeed(speed);
    if (mDirection[motorIndex])
    {
      motors[motorIndex].right(steps);
      showStatus(motorIndex, "Count up");
      atHome[motorIndex] = false;
    }
    else
    {
      if (!atHome[motorIndex])
      {
        motors[motorIndex].left(steps);
        showStatus(motorIndex, "Count down");
      }
    }
  }

  private void doConnect(boolean start)
  {
    boolean rc = fc.connect();
    if (!rc)
    {
      connectField.setBackground(Color.red);
      if (start)
        connectionBtn.setEnabled(true);
      else
      {
        JOptionPane.showMessageDialog(null, "Connection to the controller failed.\n" +
          "Check USB cable and power supply.\n" +
          "Then press the 'Connect' button",
          "Fatal error",
          JOptionPane.ERROR_MESSAGE);
      }
    }
    else
    {
      connectionBtn.setEnabled(false);
      connectionLabel.setText("Connection established");
      String deviceType = Integer.toString(fc.getDeviceType());
      String serialNumber = Integer.toString(fc.getSerialNumber());
      String firmwareInfo = fc.getFirmwareInfo();
      controllerInfo.setText("Controller info: " +
        deviceType + "/" +
        serialNumber + " V" +
        firmwareInfo);
      connectField.setBackground(Color.green);
      initDigitalIn();
    }
  }

  private void cleanup()
  {
    fc.dispose();
    System.exit(0);
  }

  protected void processWindowEvent(WindowEvent e)
  {
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      cleanup();
    else
      super.processWindowEvent(e);
  }

  public void connectionLost()
  {
    connectField.setBackground(Color.red);
    connectionLabel.setText("Connection lost. Restart program");
  }

  public void digitalChanged(DigitalEvent evt)
  {
    for (int portNb = 1; portNb <= 8; portNb++)
    {
      if (evt.isPortChanged(portNb))
      {
        if (evt.isPortOn(portNb))
          digitalIn[portNb - 1].setBackground(Color.green);
        else
          digitalIn[portNb - 1].setBackground(Color.red);
      }
    }
  }

  public void motorStopped(int motorNb, boolean isEnd)
  {
    int motorIndex = motorNb - 1;
    if (isEnd)
    {
      showStatus(motorIndex, "At home");
      setBtnText(motorIndex);
      mPositionCurrent[motorIndex] = mPositionOld[motorIndex] = 0;
      mSteps[motorIndex].setText("0");
      mPos[motorIndex].setText("0");
      mState[motorIndex] = MotorState.STOP;
      atHome[motorIndex] = true;
      allHome = true;
      for (int i = 0; i < 4; i++)
      {
        if (!atHome[i])
          allHome = false;
      }
      allHomeEnabled = !allHome;
    }
  }

  public void stepChanged(int motorNb, int step)
  {
    int motorIndex = motorNb - 1;
    if (mDirection[motorIndex])
      mPositionCurrent[motorIndex] = mPositionOld[motorIndex] + step;
    else
      mPositionCurrent[motorIndex] = mPositionOld[motorIndex] - step;

    mSteps[motorIndex].setText(Integer.toString(mPositionCurrent[motorIndex]));
  }

  private void initDigitalIn()
  {
    allHomeEnabled = false;
    allHome = true;
    for (int i = 0; i < 4; i++)
      atHome[i] = true;
    int value = fc.digitalIn.getValue();
    int mask = 1;
    for (int portIndex = 0; portIndex < 8; portIndex++)
    {
      if ((value & mask) != 0)
      {
        digitalIn[portIndex].setBackground(Color.green);
        if (portIndex % 2 == 0)
        {
          showStatus(portIndex / 2, "At home");
          mSteps[portIndex / 2].setText("0");
        }
      }
      else
      {
        digitalIn[portIndex].setBackground(Color.red);
        if (portIndex % 2 == 0)
        {
          showStatus(portIndex / 2, "Not at home");
          atHome[portIndex / 2] = false;
          allHomeEnabled = true;
          allHome = false;
        }
      }
      mask *= 2;
    }
  }

  private Dimension requestSize()
  {
    return getSize();
  }

  private void showStatus(final int motorIndex, final String text)
  {
    if (EventQueue.isDispatchThread())
      mStatus[motorIndex].setText(" " + text);
    else
      try
      {
        EventQueue.invokeAndWait(new Runnable()
        {
          public void run()
          {
            mStatus[motorIndex].setText(" " + text);
          }
        });
      }
      catch (Exception ex)
      {
      }
  }

  private void setBtnText(int motorIndex)
  {
    switch (motorIndex)
    {
      case 0:
        fwd1.setText("Right");
        back1.setText("Left");
        break;
      case 1:
        fwd2.setText("Forward");
        back2.setText("Backward");
        break;
      case 2:
        fwd3.setText("Down");
        back3.setText("Up");
        break;
      case 3:
        fwd4.setText("Grab");
        back4.setText("Release");
        break;
    }
  }

  private void setBtnFwdText(int motorIndex)
  {
    switch (motorIndex)
    {
      case 0:
        fwd1.setText("Stop");
        back1.setText("Left");
        break;
      case 1:
        fwd2.setText("Stop");
        back2.setText("Backward");
        break;
      case 2:
        fwd3.setText("Stop");
        back3.setText("Up");
        break;
      case 3:
        fwd4.setText("Stop");
        back4.setText("Release");
        break;
    }
  }

  private void setBtnBackText(int motorIndex)
  {
    switch (motorIndex)
    {
      case 0:
        fwd1.setText("Right");
        back1.setText("Stop");
        break;
      case 1:
        fwd2.setText("Forward");
        back2.setText("Stop");
        break;
      case 2:
        fwd3.setText("Down");
        back3.setText("Stop");
        break;
      case 3:
        fwd4.setText("Grab");
        back4.setText("Stop");
        break;
    }
  }

  void runBtnSetText(final String text)
  {

    if (EventQueue.isDispatchThread())
      runBtn.setText(text);
    else
      try
      {
        EventQueue.invokeAndWait(new Runnable()
        {
          public void run()
          {
            runBtn.setText(text);
          }
        });
      }
      catch (Exception ex)
      {
      }
  }

  protected boolean parseLine(String line)
  {
    int pos = line.indexOf(':');
    line = line.substring(pos + 1).trim();
    String[] tokens = line.split(";");
    for (int i = 0; i < 4; i++)
    {
      String motorState = tokens[i].trim();
      String[] speedPos = motorState.split(",");
      try
      {
        speeds[i] = Integer.parseInt(speedPos[0]);
        targetPos[i] = Integer.parseInt(speedPos[1]);
      }
      catch (NumberFormatException ex)
      {
        return false;
      }
    }
    return true;
  }

  /**
   * @param args the command line arguments
   */
  public static void main(String args[])
  {
    try
    {
      UIManager.setLookAndFeel(
        UIManager.getSystemLookAndFeelClassName());
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }

    java.awt.EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        myApp = new FtLearningRobot();
        myApp.setVisible(true);
      }
    });
  }
  // Instance variables
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton allHomeBtn;
  private javax.swing.JButton back1;
  private javax.swing.JButton back2;
  private javax.swing.JButton back3;
  private javax.swing.JButton back4;
  private javax.swing.JTextField connectField;
  private javax.swing.JButton connectionBtn;
  private javax.swing.JLabel connectionLabel;
  private javax.swing.JLabel controllerInfo;
  private javax.swing.JTextField din1;
  private javax.swing.JTextField din2;
  private javax.swing.JTextField din3;
  private javax.swing.JTextField din4;
  private javax.swing.JTextField din5;
  private javax.swing.JTextField din6;
  private javax.swing.JTextField din7;
  private javax.swing.JTextField din8;
  private javax.swing.JButton fwd1;
  private javax.swing.JButton fwd2;
  private javax.swing.JButton fwd3;
  private javax.swing.JButton fwd4;
  private javax.swing.JButton go1;
  private javax.swing.JButton go2;
  private javax.swing.JButton go3;
  private javax.swing.JButton go4;
  private javax.swing.JLabel jLabel13;
  private javax.swing.JLabel jLabel14;
  private javax.swing.JLabel jLabel15;
  private javax.swing.JLabel jLabel16;
  private javax.swing.JLabel jLabel17;
  private javax.swing.JLabel jLabel18;
  private javax.swing.JLabel jLabel19;
  private javax.swing.JLabel jLabel20;
  private javax.swing.JLabel jLabel23;
  private javax.swing.JLabel jLabel24;
  private javax.swing.JLabel jLabel25;
  private javax.swing.JLabel jLabel26;
  private javax.swing.JLabel jLabel27;
  private javax.swing.JLabel jLabel28;
  private javax.swing.JLabel jLabel29;
  private javax.swing.JLabel jLabel30;
  private javax.swing.JLabel jLabel31;
  private javax.swing.JLabel jLabel32;
  private javax.swing.JLabel jLabel33;
  private javax.swing.JLabel jLabel34;
  private javax.swing.JLabel jLabel35;
  private javax.swing.JLabel jLabel36;
  private javax.swing.JLabel jLabel37;
  private javax.swing.JLabel jLabel38;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel11;
  private javax.swing.JPanel jPanel6;
  private javax.swing.JPanel jPanel7;
  private javax.swing.JPanel jPanel8;
  private javax.swing.JPanel jPanel9;
  private javax.swing.JTextField motor1Pos;
  private javax.swing.JTextField motor1Speed;
  private javax.swing.JTextField motor1Status;
  private javax.swing.JTextField motor1Step;
  private javax.swing.JTextField motor2Pos;
  private javax.swing.JTextField motor2Speed;
  private javax.swing.JTextField motor2Status;
  private javax.swing.JTextField motor2Step;
  private javax.swing.JTextField motor3Pos;
  private javax.swing.JTextField motor3Speed;
  private javax.swing.JTextField motor3Status;
  private javax.swing.JTextField motor3Step;
  private javax.swing.JTextField motor4Pos;
  private javax.swing.JTextField motor4Speed;
  private javax.swing.JTextField motor4Status;
  private javax.swing.JTextField motor4Step;
  private javax.swing.JButton quitBtn;
  private javax.swing.JButton repeatBtn;
  private javax.swing.JButton runBtn;
  private javax.swing.JButton saveBtn;
  // End of variables declaration//GEN-END:variables
  private FtController fc;
  private JTextField[] digitalIn = new JTextField[8];
  private Motor[] motors = new Motor[4];
  private JTextField[] mStatus = new JTextField[4];
  protected JTextField[] mSpeeds = new JTextField[4];
  private JTextField[] mSteps = new JTextField[4];
  protected JTextField[] mPos = new JTextField[4];
  private boolean[] mDirection = new boolean[4];  // right: true
  private final String version = "V1.5 - April 2009";
  private int[] mPositionOld = new int[4];
  private int[] mPositionCurrent = new int[4];
  private boolean[] atHome = new boolean[4];
  private PrintWriter out = null;
  private final String filename = "ftlearningrobot.dat";
  private int nbPos = 1;
  private RunArea ra = null;
  private StringBuffer sb = null;
  private boolean allHome;
  private volatile boolean isRepeating = false;
  private volatile boolean isRunning = false;
  private volatile boolean allHomeEnabled = false;
  private int nbRun = 0;
  protected int[] speeds = new int[4];
  protected int[] targetPos = new int[4];
  private static FtLearningRobot myApp;

  private enum MotorState
  {
    FORWARD, BACK, STOP
  };
  private MotorState[] mState = new MotorState[4];

  // -------------------- Inner class Executor --------------------
  private class Executor extends Thread
  {
    public void run()
    {
      File file = new File(filename);
      if (!file.exists())
      {
        JOptionPane.showMessageDialog(null, "File '" + filename + "'" +
          "\nnot found. Perform a training session first");
        runBtnSetText("Run");
        isRunning = false;
        return;
      }
      try
      {
        EventQueue.invokeAndWait(new Runnable()
        {
          public void run()
          {
            Dimension size = requestSize();
            if (ra != null)
              ra.dispose();
            ra = new RunArea(myApp, size.width);
          }
        });
      }
      catch (Exception ex)
      {
        ex.printStackTrace();
      }

      while (isRunning)
      {
        ra.clear();
        ra.insert("Start of run #" + (++nbRun) + "\n");
        fc.delay(300);
        String line;

        try
        {
          BufferedReader in =
            new BufferedReader(new FileReader(new File(filename)));
          while ((line = in.readLine()) != null)
          {
            ra.insert(line + "\n");
            if (!myApp.parseLine(line))
            {
              JOptionPane.showMessageDialog(null,
                "Illegal format in '" + filename + "'");
              in.close();
              return;
            }
            for (int motorIndex = 0; motorIndex < 4; motorIndex++)
            {
              final int k = motorIndex;
              java.awt.EventQueue.invokeLater(new Runnable()
              {
                public void run()
                {
                  mSpeeds[k].setText("" + speeds[k]);
                  mPos[k].setText("" + targetPos[k]);
                }
              });
              moveTo(motorIndex, speeds[motorIndex], targetPos[motorIndex]);
            }
            while (fc.motorAry[0].isRotating() ||
              fc.motorAry[1].isRotating() ||
              fc.motorAry[2].isRotating() ||
              fc.motorAry[3].isRotating())
            {
              fc.delay(50);
            }
            for (int motorIndex = 0; motorIndex < 4; motorIndex++)
            {
              mPositionCurrent[motorIndex] = targetPos[motorIndex];
              mPositionOld[motorIndex] = targetPos[motorIndex];
              mState[motorIndex] = MotorState.STOP;
              showStatus(motorIndex, "Stopped");
            }

            if (!isRunning)
            {
              in.close();
              ra.insert("Stopped. Click in line to\nmove to selected position.");
              runBtnSetText("Run");
              isRepeating = false;
              ra.addCaretListener();
              return;
            }
          }
          in.close();
        }
        catch (IOException ex)
        {
          JOptionPane.showMessageDialog(null, "Can't read '" + filename + "'");
          isRunning = false;
          isRepeating = false;
          runBtnSetText("Run");
          return;
        }
        if (!isRepeating)
        {
          isRunning = false;
          runBtnSetText("Run");
        }
        ra.insert("End of run. Click in line to\nmove to selected position.");
      }
      ra.addCaretListener();
    }
  }
}